(function($, win) {

	var _dn_func = {
		_chk_ls(data){
			return data.ngp;
		}
	};

	

	// $(this)._dn_bgprem()
	$.fn._dn_bgprem = function(options) {
		return _dn_func._chk_ls(_dn_.bgprem);
	};



	$.fn._dn_update_page_color = function(options){
		var settings = $.extend({
			'color': '#f1f1f1'
		}, options );
		
		$('.bc_page').css({'background-color':settings.color});
		$('head').append('<style>ul#adminmenu a.wp-has-current-submenu:after,ul#adminmenu>li.current>a.current:after {border-right-color:'+settings.color+';}</style>');
	};





	/**
	 * CENTER MIDDLE jQuery PLUGIN
	*/
	$.fn.centerMiddle = function(options) {
	  	// Defaults
		var settings = $.extend({
			'parentRelative': window,
			'marginLeft': null, 
			'marginRight':null,
			'marginTop' : null,
			'position' : 'absolute'
		}, options );
	  
	 	return this.each(function(i,el){
		
	   		function crml(){
	   			$(document).ready(function(){
			   		var parent = $(settings.parentRelative);
			   		var parentHeight = $(parent).innerHeight();
			   		var parentWidth = $(parent).innerWidth();
			   
			   		parent.css({
						position : 'relative'
					});
			   
			   		// Clear element margin and padding to calculate actual dimensions
					$(el).css({
						margin : '',
						padding : '',
						display : 'inline-block'
					});
			   
			   		var contentWidth = $(el).outerWidth(); 
			   		var contentHeight = $(el).outerHeight();  
			   
			   		var set_left = (parentWidth - contentWidth - settings.marginLeft - settings.marginRight) / 2;
			   		var set_top = (parentHeight - contentHeight) / 2; 
			   
					return $(el).css({
						'position' : settings.position,
						'left' : set_left,
						'top' : set_top,
						'margin-left' : settings.marginLeft,
						'margin-right' : settings.marginRight,
						'margin-top' : settings.marginTop
					}); 
				});
			} //crml();
			setTimeout(crml, 300); 
			$(win).on('resize scroll', crml);  
	 	});
	};


	$(document).ready(function(){
		window.ImgMCE_global.init_imgmce({'ajaxurl': _dn_.ajaxurl}); // 'debug': parseInt(_dn_.debug),
	});

}(jQuery, window));




/**
 *  GLOBAL FUNCTIONS
 */

var ImgMCE_global = {

	// ImgMCE_global.loading_ico();
	loading_ico: function(){
		return '<svg viewBox="0 0 512 512" class="_dn_spin"><path fill="currentColor" d="M304 48c0 26.51-21.49 48-48 48s-48-21.49-48-48 21.49-48 48-48 48 21.49 48 48zm-48 368c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zm208-208c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.49-48-48-48zM96 256c0-26.51-21.49-48-48-48S0 229.49 0 256s21.49 48 48 48 48-21.49 48-48zm12.922 99.078c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.491-48-48-48zm294.156 0c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48c0-26.509-21.49-48-48-48zM108.922 60.922c-26.51 0-48 21.49-48 48s21.49 48 48 48 48-21.49 48-48-21.491-48-48-48z"></path></svg>';
	},

	// ImgMCE_global.urldecode();
	urldecode: function(url){
		return decodeURIComponent(url.replace(/\+/g, ' '));
	},

	// ImgMCE_global.is_url();
	is_url(str) {
		return /^(?:\w+:)?\/\/([^\s\.]+\.\S{2}|localhost[\:?\d]*)\S*$/.test(str); 
	},

	// ImgMCE_global.basename();
	basename(str){
		var base = new String(str).substring(str.lastIndexOf('/') + 1); 
			if(base.lastIndexOf(".") != -1)       
				base = base.substring(0, base.lastIndexOf("."));
		return base;
	},

	// ImgMCE_global.load_editor({});
	load_editor: function(options){
		// Defaults
		var settings = jQuery.extend({
			'editing': 0,
			'banner_obj': {},
			'editor': {},
			'parent_id': 0,
			'callback': null
		}, options );

		if(parseInt(_dn_.debug)){ console.log(settings); }

		var h = '';	
		var editing = JSON.stringify(settings.banner_obj) !== '{}' ? 1 : settings.editing;
		
		// Add class .Open_imgMCEModal to <html> object to prevent page scrolling. If no popup is opened yet!
		if( !jQuery('html').hasClass('Open_imgMCEModal') ){
			jQuery('html').addClass('Open_imgMCEModal');
				
			h+= '<div id="TMCimgModal" data-editing="'+editing+'">';
				h+= '<div class="TMCimgModalInner">';
					h+= '<div class="TMCimgEditor">';
						h+= '<div class="_imc_loader">';
							h+= '<div class="loading_logo">';
								h+= '<svg width="20px" height="20px" viewBox="0 0 310 426"><g><g id="bottom_xA0_Image_3_"><g><g><path fill="#FFFF00" d="M237,225c-0.33,0-0.67,0-1,0c-53.73,59.93-108.85,118.49-163,178c-0.85,0.18-0.94-0.39-1-1c26.08-58.92,51.7-118.3,77-178C178,224.67,209.67,222.67,237,225z"></path></g><g></g></g></g><g id="top_xA0_Image_3_"><g id="XMLID_3_"><g><path fill="#FFFF00" d="M289,165c0,1.33,0,2.67,0,4c-17.86,18.48-34.64,38.03-52,57c-56,0-112,0-168,0c0-1,0-2,0-3c21.5-64.83,42.62-130.05,63-196c46.33,0,92.67,0,139,0c-27.25,45.75-54.78,91.22-81,138C223,165,256,165,289,165z"></path></g><g></g></g></g></g><g id="BACK_1_"><g id="bottom_xA0_Image_1_"><g id="XMLID_5_"><g><path fill="#D7CB05" d="M149,225c0,1.33,0,2.67,0,4c-26.73,57.27-50.59,117.41-77,175c-16.02-1.31-37.3,2.63-50-2c25.93-59.4,52.98-117.69,79-177C117,225,133,225,149,225z"></path></g><g></g></g></g><g id="top_xA0_Image_1_"><g id="XMLID_4_"><g><path fill="#D7CB05" d="M133,27c0,1,0,2,0,3c-21.17,64.5-41.92,129.41-62,195c-16.33,0-32.67,0-49,0c0-1,0-2,0-3C43.17,157.5,63.92,92.59,84,27C100.33,27,116.67,27,133,27z"></path></g><g></g></g></g></g></svg>';
							h+= '</div>';
						h+= '</div>';
					h+= '</div>';
				h+= '</div>';
			h+= '</div>';
			jQuery('body').append(h);
		}

		if(parseInt(_dn_.debug)){ console.log(settings); console.log(settings.editor.callback); }
		
		jQuery.ajax({
			type: "POST",
			url: _dn_.ajaxurl,
			data: {
				"action": 'load_start_screen_template',
				"settings": JSON.stringify(settings)
			}
		}).done(function( msg ){
			var arr = JSON.parse(msg);
			if(parseInt(_dn_.debug)){console.log(arr);}

			jQuery('.TMCimgEditor').html(arr.template);

			// Fire option callback
			if(settings.callback){
				settings.callback.call(jQuery(this), arr);
			}
		});
	},


	// ImgMCE_global.pixToPerc();
	pixToPerc: function(layer, parent){
		var percent = {};
		percent.right = (parseInt(layer.css('right')) / parent.width()) * 100;
		percent.left = (parseInt(layer.css('left')) / parent.width()) * 100;
		console.log( percent.right+ ' '+percent.left );

		return percent;
	},




	/**
	 * Init function 
	 * Find all .imgmce_grid elements on the page and replace them with the actual image.
	 * 
	 * ImgMCE_global.init_imgmce();
	 * 
	*/
	init_imgmce: function(options){

		var settings = jQuery.extend({
			'debug': 0,
			'ajaxurl': '',
			'add_url': 1,
			'load_banner_script': 1,
			'load_external': 1,
			'animation': 1,
			'start_animation':"iv"
		}, options );
	
		jQuery('.imgmce_grid').each(function(index, item){

			var banner_json = '',
				obj_id = typeof(jQuery(item).data('id')) !== 'undefined' ? jQuery(item).data('id') : '',
				user_id = typeof(jQuery(item).data('u')) !== 'undefined' ? jQuery(item).data('u') : 0;

			// If all code needs to be loaded.
			if(jQuery(item).find('.imgmce_objcode_block').length){
				var thecode = JSON.parse(ImgMCE_global.urldecode(jQuery(item).find('.imgmce_objcode_block').html()));
				// Fix for older versions before v1.0.0
				if(typeof(thecode.banner_obj) !== 'undefined'){
					thecode = thecode.banner_obj;
				}
				banner_json = thecode;

				// Load Editor Template
				jQuery.ajax({
					type: "POST",
					url: settings.ajaxurl,
					async: false,
					data: {
						"action": "load_banner",
						"id": obj_id,
						"user_id": user_id,
						"banner_obj": JSON.stringify(banner_json),
						"debug":settings.debug,
						"args": JSON.stringify({
							"add_url": settings.add_url, 
							"load_banner_script": settings.load_banner_script, 
							"load_external": settings.load_external, 
							"animation": settings.animation, 
							"start_animation":settings.start_animation
						})
					}
				}).done(function( msg ){
					var arr = JSON.parse(msg);
					
					if(settings.debug){ console.log(arr); }
					jQuery(item).replaceWith(arr.template);
				});
			}else{
				if( !jQuery('body').hasClass('wp-admin')){
					jQuery(item).find('.imgmce_header').remove();
					jQuery(item).show().find('._dn_cont').unwrap();
					// In case it's still wrapped in .imgmce_grid container
					if( jQuery(item).show().find('._dn_cont').parent().hasClass('imgmce_grid') ){
						jQuery(item).show().find('._dn_cont').unwrap();
					}
				}
			}
		});
	},
	

	// ImgMCE_global.create_url_from_structure(structure, args);
	create_url_from_structure: function(structure, args){

		args = jQuery.extend({
			'id': '',
			'uid': 0,
			'dir': '',
			'folder': 'user_uploads'
		}, args);

		structure = structure.replace("{ID}", args.id);
		structure = structure.replace("{UID}", args.uid);
		structure = structure.replace("{DIR}", args.dir.replace(/\/+$/,''));
		structure = structure.replace("{FOLDER}", args.folder.replace(/\/+$/,''));
		structure = structure.replace(/\/+$/,'');

		return structure+'/';
	},


	// ImgMCE_global.activate_tooltips();
	activate_tooltips: function(_obj){
		_obj.find(".ttip").tooltipster({
			theme: "tooltipster-light",
			functionInit: function(instance, helper){
				var $origin = jQuery(helper.origin),
					dataOptions = $origin.attr('data-tooltipster');
		
				if(dataOptions){
					dataOptions = JSON.parse(dataOptions);
		
					jQuery.each(dataOptions, function(name, option){
						instance.option(name, option);
					});
				}
			}
		});
	},




	// ImgMCE_global.editor_grid_tpl();
	editor_grid_tpl: function(options){
			
		if(typeof(options) !== 'undefined'){
			var h = '',
				json = options.json;
				classes = typeof(options.classes) !== 'undefined' ? ' '+options.classes : ''; // for .imgmce_grid container
				style = typeof(options.style) !== 'undefined' ? ' '+options.style : ''; // for .imgmce_grid container
				
			var banner_obj = JSON.parse(json).banner_obj;
			var logo = typeof(_spr_) !== 'undefined' ? _spr_.logo : '/images/logo_20.png';
			var load_code = typeof(options.code) !== 'undefined' ? options.code : 1;
			var align = 'margin:0 auto;';
			align = banner_obj.align == 'left' ? 'float:left;margin:0.5em 1em 0.5em 0;' : align;
			align = banner_obj.align == 'right' ? 'float:right;margin:0.5em 0 0.5em 1em;' : align;
			//load_code = !banner_obj.user_id ? 1 : load_code;
			
			h+= '<div class="imgmce_grid'+classes+'" style="width:'+banner_obj.size.w+'px;height:'+banner_obj.size.h+'px;'+align+style+'" data-id="'+banner_obj.id+'" data-u="'+banner_obj.user_id+'" contenteditable="false">';
				h+= '<div class="imgmce_header">';
					h+= '<img src="'+_dn_.assets_url+logo+'" /> ImgMCE: #'+banner_obj.id+' - '+banner_obj.title+' ('+banner_obj.size.full+')';
					h+= load_code ? ' - F' : ' - S'
				h+= '</div>';
				h+= load_code ? '<pre class="imgmce_objcode_block">'+encodeURIComponent(JSON.stringify(banner_obj))+'</pre>' : '<div class="imgmce_element">[imgmce_element id="'+banner_obj.id+'" user_id="'+banner_obj.user_id+'"]</div>';
			h+= '</div>';

			return h;
		}

		var c = '';
		c+= '.imgmce_grid{background-color:#feffcb;}'; /*background-color: #f9f9f9;*/
		c+= '.imgmce_header, .imgmce_element{';
			c+= 'font-size: 10px;';
			c+= 'background-color: #feffcb;';
			c+= 'padding: 10px;';
			c+= 'border-radius: 2px;';
		c+= '}';
		c+= '.imgmce_element{';
			c+= 'color:#feffcb;';
		c+= '}'
			c+= '.imgmce_header img{';
				c+= 'width:10px;';
				c+= 'vertical-align:sub;';
			c+= '}';
		c+= '.imgmce_objcode_block{';
			c+= 'margin:0;line-height:0;visibility:hidden;overflow:hidden;padding:0;';
		c+= '}'; 
		c+= '.imgmce_code_block {';
			c+= 'display:inline-block;width:60px;height:30px;font-size:6px;overflow:auto;background-color:#f3f3f3;padding:5px;margin:1px;';
		c+= '}';
		c+= '.mce-content-body .imgmce_grid[contentEditable=false][data-mce-selected] {';
			c+= 'outline: 2px solid #eaef00;';
		c+= '}';
		
		return c;
	}
};


function InitImgMCE(){
	ImgMCE_global.init_imgmce({ajaxurl: _dn_.ajaxurl});
}

module.exports = { 
	InitImgMCE,
	ImgMCE_global,
	InitImgMCE
};