<?php
// Exit if accessed directly
if ( ! defined("IMC_VERSION") ) exit;
if ( ! class_exists( 'ADN_AMP' ) ) :

class ADN_AMP {


    public function __construct() 
	{
        // Actions --------------------------------------------------------

        // Filters --------------------------------------------------------
    }



    
    /**
	 * Check if page is AMP
	 * Note: always returns false and PHP Notice when called before the parse_query hook.
	 *
	 * return bool (true if AMP URL)
	*/
	public static function is_amp() 
	{
		if( defined( 'DOING_AJAX' ) && DOING_AJAX ) 
			return false;
        
        if( function_exists( 'is_amp_endpoint' ) && is_amp_endpoint() || function_exists( 'is_wp_amp' ) && is_wp_amp() || isset( $_GET [ 'wpamp' ] ) )
            return true;
        
        return apply_filters('adning_is_amp', false);
    }



}
endif;
?>