<?php
// Exit if accessed directly
if( !defined("IMC_VERSION")) exit;
if ( ! class_exists( 'ADN_Filters' ) ) :

class ADN_Filters {

    public static $collect_js = array();
	
	public function __construct() 
	{
        // Actions --------------------------------------------------------
        add_action( 'wp_footer', array( __CLASS__, 'add_to_footer' ), PHP_INT_MAX );
        add_action( 'admin_footer', array( __CLASS__, 'add_to_footer' ), PHP_INT_MAX );
        
        // Filters --------------------------------------------------------
        add_filter( 'imgmce_api_footer', array( __CLASS__, 'add_to_footer' ), PHP_INT_MAX, 2 );
    }




    public static function add_to_footer($h = '', $echo = true)
    {
        $output = '';
        $marker = '<!-- Animations on this site are created with imgMCE v' . IMC_VERSION . ' - imgmce.com -->';
        $output.= "\n${marker}\n";
        $output.= $h;

        /**
         * Add collected javascript to footer
         */
        $js = '';
		if(!empty(self::$collect_js))
		{
			foreach(self::$collect_js as $js)
			{
				$output.= $js;
			}
		}
        $output.= '<!-- / '."imgMCE. -->\n\n";

        if( $echo )
        {
            echo $output;
        }
        else
        {
            return $output;
        }
    }

}
endif;
?>