<?php
if ( ! class_exists( 'ADN_Scripts' ) ) :

class ADN_Scripts {	
	
	
	public static function display()
	{
		$html = '';
		/*
		$html.= 'var display = "undefined"!==typeof s.display ? "&display="+s.display.type+";" : "";';
		$html.= 'var display_class = "undefined"!==typeof s.display ? " "+s.display.type : "";';
		*/
		$html.= 'var display = "";';
		$html.= 'var display_class = "";';
		$html.= 'var display_attr = {};';

		$html.= 'if("undefined"!==typeof s.display){';

			$html.= 'display = "&display="+s.display.type+";";';
			$html.= 'display_class = " "+s.display.type;';

			// Popup
			$html.= 'if(s.display.type == "popup"){';
				$html.= 'display_attr = "undefined"!==typeof s.display.attr ? s.display.attr : {"close_btn":{"delay":0}};';
				$html.= 'display_attr = jQuery.extend({
					bg_color: "#0000009e"
				}, display_attr );';
			$html.= '}';

		$html.= '}';
		
		return $html;
	}







	/**
	 * Enter view port detection
	*/
	public static function adnInViewport(){
		return '(function(d,h){d.fn.adnInViewport=function(k,a){var e=d.extend({padding:0,delay:200},a);return this.each(function(a,g){function b(){var f=d(this).height(),c=g.getBoundingClientRect(),a=c.top+e.padding;c=c.bottom+e.padding;var b=Math.max(0,0<a?f-a:c<f?c:f);0!==b&&setTimeout(function(){return k.call(g,b)},e.delay)}b();d(h).on("resize scroll",b)})}})(jQuery,window);';
	}

	
	
	
	/**
	 * Display as popup
	*/
	public static function popup()
	{
		$html.= 'if("undefined"!==typeof s.display){';
			$html.= 'if(s.display.type == "popup"){';
				
				$html.= 'jQuery(document).ready(function($){';
					$html.= 'var bframe_holder = $("#_dn_holder_"+s.hash);';
					$html.= 'var bframe = $("#_dn_holder_"+s.hash+" iframe");';
					$html.= '';
					
					$html.= 'bframe_holder.css({"opacity":0});';
					// Show iframe holder
					$html.= 'bframe_holder.adnInViewport(';
						$html.= 'function(px){';
							$html.= 'if(px){';
								$html.= 'bframe.centerMiddle();';
								$html.= 'jQuery(this).css({"opacity":1,"position": "fixed","max-height":"100%","max-width":"100%","background": display_attr.bg_color,"text-align":"center","left": 0,"top": 0,"right": 0,"bottom": 0,"z-index":9999});';
								$html.= 'jQuery("body").addClass("_dn_popup");';

								// Close btn
								$html.= 'if( bframe_holder.find("._dn_popup_close_btn").length == 0){';
									$html.= 'bframe_holder.append("<span class=\'_dn_popup_close_btn _dn_popup_close_btn_"+s.hash+"\' style=\"opacity:0;\">X</span>");';
									$html.= '$("._dn_popup_close_btn_"+s.hash).centerMiddle({';
										$html.= 'marginLeft:  bframe.width()+$("._dn_popup_close_btn_"+s.hash).width(),';
										$html.= 'marginTop:  -bframe.height()/2';
									$html.= '});';
									// Show close btn (delay?)
									$html.= 'setTimeout(function() { 
										$("._dn_popup_close_btn_"+s.hash).css({"opacity":1});
									}, display_attr.close_btn.delay);';
								$html.= '}';

							$html.= '}';
						$html.= '},{"delay":delay}';
					$html.= ');';
					
					// Close btn
					/*$html.= 'bframe_holder.append("<span class=\'_dn_popup_close_btn _dn_popup_close_btn_"+s.hash+"\' style=\"opacity:0;\">X</span>");';
					// Show close btn
					$html.= '$("._dn_popup_close_btn_"+s.hash).adnInViewport(';
						$html.= 'function(px){';
							$html.= 'if(px){';
								$html.= 'jQuery(this).css({"opacity":1});';
								//$html.= 'jQuery(this).addClass(s.animation+" animated");';
								$html.= '$("._dn_popup_close_btn_"+s.hash).centerMiddle({';
									$html.= 'marginLeft:  bframe.width()+$("._dn_popup_close_btn_"+s.hash).width(),';
									$html.= 'marginTop:  -bframe.height()/2';
								$html.= '});';
							$html.= '}';
						$html.= '}';
					$html.= ');';*/
					
					//Close btn CLICK
					$html.= '$("body").on("click","._dn_popup_close_btn_"+s.hash, function(){';
						$html.= '$("#_dn_holder_"+s.hash).remove();';
						$html.= '$("body").removeClass("_dn_popup");';
					$html.= '});';
					
					// CSS
					$html.= 'bframe_holder.append("<style>';
						$html.= 'body._dn_popup{';
							$html.= 'overflow:hidden;';
						$html.= '}';
						$html.= '._dn_popup_close_btn_"+s.hash+"{';
							$html.= 'background-color:#a9a9a9;';
							$html.= 'padding:15px 10px;';
							$html.= 'line-height:0;';
						$html.= '}';
						$html.= '._dn_popup_close_btn{';
							$html.= 'position:fixed;';
							$html.= 'z-index:99999;';
							$html.= 'cursor:pointer;';
						$html.= '}';
					$html.= '</style>");';
					
				$html.= '});';
						
			$html.= '}';
		$html.= '}';
		// end if popup
		
		
		return $html;
	}
	
	
	
	
	/**
	 * Horizontal/vertical center popups
	*/
	public static function centerMiddle()
	{
		return ";(function($, win) {
		  $.fn.centerMiddle = function(options) {
			  
			  // Defaults
				var settings = $.extend({
					'parentRelative': window,
					'marginLeft': null, 
					'marginRight':null,
					'marginTop' : null,
					'position' : 'absolute'
				}, options );
			  
			 return this.each(function(i,el){
				
			   function crml(){
				   var parent = $(settings.parentRelative);
				   var parentHeight = $(parent).innerHeight();
				   var parentWidth = $(parent).innerWidth();
				   
				   parent.css({
						position : 'relative'
					});
				   
				   // Clear element margin and padding to calculate actual dimensions
					$(el).css({
						margin : '',
						padding : '',
						display : 'inline-block'
					});
				   
				   var contentWidth = $(el).outerWidth(); 
				   var contentHeight = $(el).outerHeight();  
				   
				   var set_left = (parentWidth - contentWidth - settings.marginLeft - settings.marginRight) / 2;
				   var set_top = (parentHeight - contentHeight) / 2; 
				   
					return $(el).css({
						'position' : settings.position,
						'left' : set_left,
						'top' : set_top,
						'margin-left' : settings.marginLeft,
						'margin-right' : settings.marginRight,
						'margin-top' : settings.marginTop
					}); 
			   } crml();
			   $(win).on('resize scroll', crml);
			 });
		  };
		}(jQuery, window));";	
	}
	
}

endif;
?>