<?php
/**
 * Usage:
 *
 * require_once(DIR. '/spr_selectbox/SPR_SelectBox.php');
 * new SPR_SelectBox();
 * SPR_SelectBox::enqueue_scripts(array('inc_url' => '', 'version' => 0));
 *
 *
 * Usage:
 * 
 	$('#select_box')._dn_selectBox({
		'options': [
			{'value': 'option_1', 'option': 'Option 1', 'disabled': true, 'action': function(value, option){alert('This option ('+value+' - '+option+') is disabled.')} },
			{'value': 'option_2', 'option': 'Option 2', 'selected': true },
			{'value': 'option_3', 'option': '<span style="color:#f3a22e;">Option 3</span><div style="position:absolute;top:5px;right:15px;background-color:#ffa500b8;border-radius:3px;padding:0px 4px 1px;font-size:11px;color:#ffffff;">new</div>' },
			{'value': 'option_4', 'option': 'Option 4'},
			{'value': 'option_5', 'option': 'Option 5'},
		]
	});
 *
*/
if ( ! class_exists( 'IMC_SelectBox' ) ) :

class IMC_SelectBox {


	public function __construct() {
		
	}




	/*
	 * register_scripts
	 *
	 * @access public
	 * @return null
	*/
	public static function register_scripts($args = array())
	{
		global $imc_scripts;

		$defaults = array(
			'version' => 1,
			'inc_url' => '',
			'inc_dir' => '',
		);
		$args = array_merge( $defaults, $args );
		
		// Scripts
		$imc_scripts->register_script( 'imc_selectbox_js', $args['inc_url']. '/extensions/imc_selectbox/assets/js/spr_selectBox.js', array( 'jquery' ), $args['version'], true );
		
		// Styles
		$imc_scripts->register_script( 'imc_selectbox_css', $args['inc_url']. '/extensions/imc_selectbox/assets/css/style.css', false, $args['version'], "all" );
	}

}
endif;
?>