(function($, win) {    

    $.fn._imc_animate_shape_width = function(options){
		var settings = $.extend({
            'speed': 1000,
            'callback': null
        }, options );
        
        return this.each(function(i,el){
		
            var w = $(el).width();
            $(el).css({width:0});
            $(el).animate({width: w},settings.speed, function() {
                if (typeof(settings.callback) == 'function'){
                    settings.callback.call(el);
                }
            });
        });
	};

}(jQuery, window));