<!-- Wordpress Messages -->
<h2 class="messages-position"></h2>


<div class="imgmce_dashboard">
	<div class="wrap">
       
		<?php 
		$activation = get_option('imgmce_activation', array());
		$tip = empty($activation) ? ' <span style="background-color:#e4ff00;">'.__('Tip: start by activting your Product License.','imc').'</span>' : '';

		echo IMC_Templates::admin_header(array(
			'title' => sprintf('Welcome to imgMCE - v%s', IMCE_VERSION),
			'desc' => '⚡ ' . __('Congratulations! You are about to use the most powerful image editor/HTML element builder plugin for Wordpress ever. Let\'s get started and make your content shine!','imc').$tip,
			'tabs' => 0
		)); 
		?>

		<div>
			<a href="?page=imgmce-settings" class="button button-primary"><?php _e('Settings','imc'); ?></a>
		</div>

		<?php 
		$tab = isset($_GET['tab']) ? $_GET['tab'] : 'faq';
		echo IMC_Templates::about_tabs(array('tab' => $tab)); 
		?>

		<div class="container">
			
			<?php 
			if( $tab ==  'faq')
			{
				?>
				<div class="spr_row">  
					<div class="spr_column spr_hidden" data-animation="fadeInLeft">
						<div class="spr_column-inner left_column">
							<div class="spr_wrapper">
								<div> <!-- class="option_box" -->
									<div class="input_container">
										<div class="input_container_inner _imc_editor">
											<div style="margin: 20px 0 30px 0; font-size: 14px;max-width:960px;">
												<!--⚡-->
												<p style="font-size:15px;">
													<?php echo sprintf(__('ImgMCE has complete online documentation available at our website: %s which covers everything related to imgMCE image editor starting from Installation and up to more advanced features like our Inner API.', 'imc'), '<a href="http://support.imgmce.com/docs" target="_blank">support.imgmce.com</a>'); ?>
												</p>
											</div>
											<div>
												<a href="http://support.imgmce.com/docs/where-do-i-get-the-license-key/" target="_blank"><?php _e('Where do I get my license key?'); ?></a>
											
											</div>

										</div>
									</div>
								</div>
							</div>
							<!-- end .spr_wrapper -->
						</div>
					</div>
					<!-- end .spr_column -->
				<?php
			}
			if( $tab ==  'resources')
			{
				?>
				<div class="spr_row">  
					<div class="spr_column spr_col-6 spr_hidden" data-animation="fadeInLeft">
						<div class="spr_column-inner left_column">
							<div class="spr_wrapper">
								<div> <!-- class="option_box" -->
									<div class="input_container">
										<div class="input_container_inner _imc_editor">
											<div style="margin: 20px 0 30px 0; font-size: 14px;max-width:960px;">
												<!--<h3><?php _e('Resources','imc'); ?></h3>-->
												<ul>
													<li><a href="http://imgmce.com" target="_blank"><?php _e('Official Website','imc'); ?></a></li>
													<li><a href="http://support.imgmce.com/docs" target="_blank"><?php _e('Official Documentation','imc'); ?></a></li>
												</ul>

												<h4 style="margin-top:80px;"><?php _e('Asset Libraries','imc'); ?></h4>
												<ul>
													<li><a href="https://unsplash.com/" target="_blank">Unsplash</a></li>
													<li><a href="https://giphy.com/" target="_blank">GIPHY</a></li>
													<li><a href="https://flaticon.com/" target="_blank">Flaticon</a></li>
													<li><a href="https://fontawesome.com/" target="_blank">Font Awesome</a></li>
													<li><a href="https://fonts.google.com/" target="_blank">Google Fonts</a></li>
												</ul>
											</div>

										</div>
									</div>
								</div>
							</div>
							<!-- end .spr_wrapper -->
						</div>
					</div>
					<!-- end .spr_column -->
				<?php
			}
			?>

			
		</div>
		<!-- end .container -->
        
        
        
    </div>
    <!-- end .wrap -->
</div>
<!-- end .adning_dashboard -->




<script type="text/javascript">
jQuery(document).ready(function($) {
	$(".spr_column").inViewport(function(px){
		var animation = $(this).data('animation');
		if( typeof animation !== 'undefined' && animation != ''){
			if(px) $(this).addClass(animation+" spr_visible animated");
		}
	}, {padding:0});
});
</script>

