( function( $ ) {
	/**
 	 * @param $scope The Widget wrapper element as a jQuery element
	 * @param $ The jQuery alias
	 */ 
	/*var Widget_imgMCE_Handler = function( $scope, $ ) {
		console.log( $scope );
	};*/
	
	// Make sure you run this code under Elementor.
	$( window ).on( 'elementor/frontend/init', function() {
		//elementorFrontend.hooks.addAction( 'frontend/element_ready/imgmce.default', Widget_imgMCE_Handler );

		if ( typeof(elementor) !== 'undefined' ) {
			elementor.hooks.addAction( 'panel/open_editor/widget/imgmce', function( panel, model, view ) {
				/*console.log('tst');
				console.log( panel );
				console.log( model );
				console.log( view );*/

				panel.$el.find( '.elementor-control-tag-area' ).hide();

				var code = panel.$el.find( '.elementor-control-tag-area' ).val();
				var code_obj = {};

				if( code !== ''){
					code_obj.id = typeof($(code).data('id')) !== 'undefined' ? $(code).data('id') : '';
					code_obj.user_id = typeof($(code).data('u')) !== 'undefined' ? $(code).data('u') : 0;
					
					if($(code).find('.imgmce_objcode_block').length){
						var thecode = JSON.parse(ImgMCE_global.urldecode($(code).find('.imgmce_objcode_block').html()));
						// Fix for older versions before v1.0.0
						if(typeof(thecode.banner_obj) !== 'undefined'){
						  thecode = thecode.banner_obj;
						}
						code_obj.banner_obj = thecode;
						code_obj.editing = 1;
						code_obj.editor = typeof(code_obj.editor) !== 'undefined' ? code_obj.editor : {};
					}
				}
				
				var $element = panel.$el.find( '.elementor-control-popover-toggle-toggle-label' );
				console.log( $element.length );
				if ( $element.length ) {
					$element.click( function() {

						//$('#'+model.attributes.id).addClass("elementor-element-editable");
						console.log( model.attributes.id );
						//$('.elementor-element-'+model.attributes.id).find('.elementor-widget-container').html('ikos');
						//panel.$el.find( '.elementor-control-tag-area' ).val('ikos').trigger('input');
						console.log( panel.$el.find( '.elementor-control-tag-area' )[0].id );
						console.log( panel.$el.find( '.elementor-control-tag-area' ).val() );
						
						var defaults = { 
							'active_editor': '.elementor-element-'+model.attributes.id,
							'in_popup':1,
							'save_to_folder': 0,
							'callback': "_imc_save_to_elementor" 
						}
						code_obj.editor = $.extend(defaults, code_obj.editor);
			
						ImgMCE_global.load_editor(code_obj);
					} );
				}
			});
		}

	} );

	
} )( jQuery );



function _imc_save_to_elementor(_obj, arr, settings){

	jQuery(document).ready(function($){
	
    //var $ = jQuery;
	if ( window.elementorFrontend ) {
		elementor.hooks.addAction( 'panel/open_editor/widget/imgmce', function( panel, model, view ) {
		
			// Insert content in tinymce editor
			var editing = $('body').find('#TMCimgModal').data('editing'),
				load_code = settings.editor.return_all_code;
				active_editor = settings.editor.active_editor,
				msg = JSON.stringify(arr),
				debug = settings.editor.debug;

			console.log('insert into tinymce editor ID:'+active_editor);
			//console.log( ImgMCE_global.editor_grid_tpl({'json':msg, 'code':load_code}) );
			panel.$el.find( '.elementor-control-tag-area' ).val( ImgMCE_global.editor_grid_tpl({'json':msg, 'code':load_code, 'style': 'display:block;'}) ).trigger('input');
			
			$(window).find('.elementor-element-'+model.attributes.id).find('.elementor-widget-container').html('test');
			//$(active_editor).find('.elementor-widget-container').html( ImgMCE_global.editor_grid_tpl({'json':msg, 'code':load_code, 'style': 'display:block;'}) );
			
		});
	}
	
	
	});
}