<?php
// Exit if accessed directly
if( !defined("IMC_VERSION")) exit;
if ( ! class_exists( 'ADN_JSON_Templates' ) ) :

class ADN_JSON_Templates {

    
    /**
     * Button Templates
     */
    public static function buttons()
	{
		$arr = array(
			array(
                'id' => 'button-1',
                'name' => 'Button default',
                'tags' => 'button',
                'group' => '',
                'animation' => 0,
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"200","height":"auto","top":0,"left":0},"obj":{"opacity":1,"filter":"blur(0px)"},"element":{"border-radius":0,"border-width":4,"border-style":"solid"}},"actions":{},"animation":{},"render_html":0,"type":"text","class":"hrgKJ8","aspect_ratio":"0","content":"%3Cdiv%20class%3D%22_dn_elem%20_dn_text%22%20style%3D%22border-radius%3A%200px%3B%20border-width%3A%204px%3B%20border-style%3A%20solid%3B%22%3E%3Ch1%20class%3D%22text%20heading%22%3EGET%20IT%3C%2Fh1%3E%3C%2Fdiv%3E"},"external":{}}'
            ),
            array(
                'id' => 'button-2',
                'name' => 'Button default',
                'tags' => 'button',
                'group' => '',
                'animation' => 0,
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"200","height":"auto","top":0,"left":0},"obj":{"opacity":1,"filter":"blur(0px)"},"element":{"border-radius":0,"border-width":4,"border-style":"solid","background":"rgba(0,0,0,1.01)","color":"rgba(255,255,255,1.01)","border-color":"rgba(255,255,255,1.01)"}},"actions":[],"animation":[],"render_html":0,"type":"text","class":"isKBFo","aspect_ratio":"0","content":"%3Cdiv%20class%3D%22_dn_elem%20_dn_text%22%20style%3D%22border-radius%3A%200px%3B%20border-width%3A%204px%3B%20border-style%3A%20solid%3B%20background%3A%20rgb(0%2C%200%2C%200)%3B%20color%3A%20rgb(255%2C%20255%2C%20255)%3B%20border-color%3A%20rgb(255%2C%20255%2C%20255)%3B%22%3E%3Ch1%20class%3D%22text%20heading%22%3EGET%20IT%3C%2Fh1%3E%3C%2Fdiv%3E"},"external":{}}'
            ),
            array(
                'id' => 'button-3',
                'name' => 'Button default',
                'tags' => 'button',
                'group' => '',
                'animation' => 0,
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":150,"height":39,"top":87,"left":99},"obj":{"font-size":9,"font-family":"Annie+Use+Your+Telescope","opacity":1,"filter":"blur(0px)"},"element":{"color":"rgba(255,209,204,1.01)","background":"linear-gradient(180deg,+rgba(255,117,117,1.01)+0%,rgba(255,36,36,1.01)+100%)","border-radius":2,"border-width":1,"border-style":"solid","border-color":"rgba(255,222,222,1.01)"}},"actions":[],"animation":[],"render_html":0,"type":"text","class":"0VNGtB","aspect_ratio":"0","content":"%3Cdiv%20class%3D%22_dn_elem%20_dn_text%22%20style%3D%22font-size%3A%209px%3B%20font-family%3A%20%26quot%3BAnnie%20Use%20Your%20Telescope%26quot%3B%3B%20color%3A%20rgb(255%2C%20209%2C%20204)%3B%20background%3A%20linear-gradient(rgb(255%2C%20117%2C%20117)%200%25%2C%20rgb(255%2C%2036%2C%2036)%20100%25)%3B%20border-radius%3A%202px%3B%20border-width%3A%201px%3B%20border-style%3A%20solid%3B%20border-color%3A%20rgb(255%2C%20222%2C%20222)%3B%22%3E%3Ch1%20class%3D%22text%20heading%22%3EGET%20IT%20-%26gt%3B%3C%2Fh1%3E%3C%2Fdiv%3E"},"external":{"styles":{}}}'
            ),
            array(
                'id' => 'button-4',
                'name' => 'Button default',
                'tags' => 'button',
                'group' => '',
                'animation' => 0,
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":114,"height":36,"top":13,"left":13},"obj":{"font-family":"Montserrat","font-size":6},"element":{"background":"linear-gradient(90deg, rgba(66,230,255,1.01) 0%,rgba(0,162,255,1) 91%)","color":"rgba(255,255,255,1.01)"}},"actions":{},"animation":{},"render_html":0,"type":"text","class":"14TipE","aspect_ratio":"0","content":"%3Cdiv%20class%3D%22_dn_elem%20_dn_text%22%20style%3D%22font-family%3A%20Montserrat%3B%20background%3A%20linear-gradient(90deg%2C%20rgb(66%2C%20230%2C%20255)%200%25%2C%20rgb(0%2C%20162%2C%20255)%2091%25)%3B%20font-size%3A%206px%3B%20color%3A%20rgb(255%2C%20255%2C%20255)%3B%22%3E%3Ch1%20class%3D%22text%20heading%22%3EGET%20IT%3C%2Fh1%3E%3C%2Fdiv%3E"},"external":{"styles":{"Montserrat":{"font":"Montserrat","url":"https://fonts.googleapis.com/css?family=Montserrat"}}}}'
            )
		);

		return apply_filters('_json_buttons', $arr);
    }



    /**
     * HTML Shape Templates
     */
    public static function html_shapes()
    {
        $arr = array(
           /* array(
                'id' => 'cricet_pink_rectangle',
                'name' => 'Cricet Pink Rectangle',
                'json' => '{"layer":{"css":{"layer":{"z-index":1,"width":227,"height":60,"top":85,"left":128},"element":{"background":"rgba(204,0,255,1.01)"},"obj_cont":{"transform":"rotate(-19.054809118275617deg)"}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"7fjgcK","aspect_ratio":"0","content":"%3Cdiv%20class%3D%22square%20_dn_elem%20html_shape%20shape%22%20style%3D%22width%3A%20100%25%3B%20height%3A%20100%25%3B%20background%3A%20rgb(204%2C%200%2C%20255)%3B%20border-radius%3A%205px%3B%22%3E%3C%2Fdiv%3E"},"external":{}}'
            ),*/
        );

        return apply_filters('_json_html_shapes', $arr);
    }



    /**
     * Sticker Templates
     */
    public static function stickers()
    {
        $arr = array(
            array(
                'id' => 'imgmce_handdrawn_logo',
                'name' => 'Handdrawn imgMCE logo',
                'tags' => 'imgmce logo animation',
                'group' => 'hand-drawn-graphics',
                'animation' => 1,
                'aspect_ratio' => 1,
                'size' => '90x90',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"90","height":"90","top":0,"left":0}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"RmJY9c","aspect_ratio":"1","content":"%3Csvg+class%3D%22_dn_ani%22+viewBox%3D%220+0+562+577.471%22%3E%0A%3Cg%3E%0A%09%3Cpath+class%3D%22colorful+c1%22+fill%3D%22none%22+stroke%3D%22%23000000%22+stroke-width%3D%226.3853%22+stroke-linecap%3D%22round%22+d%3D%22%0A%09%09M426.056%2C110.615c-4.884-17.071-12.84-32.996-18.556-49.722l7-4.857c27.306%2C14.704%2C52.93%2C36.27%2C71.752%2C54.109%0A%09%09c74.347%2C70.466%2C82.461%2C149.52%2C61.6%2C240.495c-0.918%2C4.004-2.994%2C11.451-4.861%2C18.039c-22.888%2C80.746-68.216%2C147.818-144.187%2C178.374%0A%09%09c-18.54%2C7.457-41.594%2C14.001-67.079%2C18.355C182.835%2C590.849%2C30.643%2C542.229%2C9.321%2C374.183c-2.956-23.294-5.007-58.902-2.305-88.062%0A%09%09C21.267%2C132.373%2C143.822-22.6%2C313.363%2C14.711%22%3E%3C%2Fpath%3E%0A%09%3Cpath+class%3D%22colorful+c2%22+fill%3D%22none%22+stroke%3D%22%23000000%22+stroke-width%3D%225.5888%22+stroke-linecap%3D%22round%22+d%3D%22%0A%09%09M214.5%2C471.893c17.435-47.895%2C33.938-95.657%2C46.333-145.104c-16.147-1.152-32.94-1.004-49.236-1.965%0A%09%09c13.073-56.969%2C23.37-120.021%2C49.154-173.074c38.938-0.785%2C80.387-5.217%2C118.124%2C1.99c-29.695%2C37.611-61.574%2C76.14-81.897%2C119.612%0A%09%09c28.546%2C3.878%2C59.042-5.488%2C86.875-1.204c-56.624%2C57.441-88.036%2C107.949-128.104%2C158.994%0A%09%09c-12.692%2C16.169-25.556%2C35.718-38.998%2C47.001L214.5%2C471.893z%22%3E%3C%2Fpath%3E%0A%3C%2Fg%3E%0A%3C%2Fsvg%3E"},"external":{}}'
            ),
            array(
                'id' => 'highlite-line-ani',
                'name' => 'Highlite Line',
                'tags' => 'highlite line animation marker',
                'group' => 'hand-drawn-graphics',
                'animation' => 1,
                'aspect_ratio' => 1,
                'size' => '90x90',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"90","height":"90","top":0,"left":0}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"OxYBmG","aspect_ratio":"1","content":"%3Csvg+class%3D%22_dn_ani%22+viewBox%3D%220+0+386+61%22%3E%0A%3Cpath+class%3D%22colorful+c1%22+fill%3D%22none%22+stroke%3D%22%23000000%22+stroke-width%3D%2230%22+stroke-miterlimit%3D%2210%22+d%3D%22M14.359%2C30.333l57.634%2C0.805%0A%09c0%2C0%2C7.711-0.594%2C18.484-0.85c24.808-0.588%2C65.902-1.524%2C65.902-1.524l79.017%2C0.568l75.642%2C1.652c0%2C0%2C3.851%2C0.191%2C9.614%2C0.494%0A%09c17.342%2C0.913%2C50.188%2C4.2%2C50.188%2C4.2%22%3E%3C%2Fpath%3E%0A%3C%2Fsvg%3E"},"external":{}}'
            ),
            array(
                'id' => 'lightning-handdrawn-ani',
                'name' => 'Hand drawn lightning',
                'tags' => 'lightning bolt animation',
                'group' => 'hand-drawn-graphics',
                'animation' => 1,
                'aspect_ratio' => 1,
                'size' => '90x90',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"90","height":"90","top":0,"left":0},"obj":{"opacity":1,"filter":"blur(0px)"}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"RgYgR2","aspect_ratio":"1","content":"%3Csvg+class%3D%22_dn_ani%22+viewBox%3D%220+0+193+349%22%3E%0A%3Cg%3E%0A++%09%3Cpath+class%3D%22colorful+c1%22+data-play%3D%221%22+fill-rule%3D%22evenodd%22+clip-rule%3D%22evenodd%22+fill%3D%22none%22+stroke%3D%22%23000000%22+stroke-width%3D%226%22+stroke-linecap%3D%22round%22+d%3D%22%0A%09%09M27.786%2C295.643C21.437%2C308.429%2C17.48%2C322.131%2C13%2C335.667l2.75%2C4.083c15.239-13.339%2C26.375-31.047%2C38.439-46.424%0A%09%09c39.463-50.303%2C70.227-99.791%2C128.664-159.571c-27.943-4.182-58.312%2C4.89-87.122%2C1.36c20.62-43.792%2C52.893-82.19%2C82.04-120.122%0A%09%09c-38.261-6.478-79.053-2.598-118.02-1.636C33.595%2C66.339%2C24.664%2C128.743%2C10.09%2C185.972c16.122%2C1.958%2C33.481%2C0.996%2C49.743%2C2.425%0A%09%09c-1.242%2C8.207-7.913%2C30.918-14.85%2C53.34C36.58%2C268.902%2C27.786%2C295.643%2C27.786%2C295.643%22+style%3D%22stroke-dasharray%3A+1006.36%2C+1006.36%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A++%0A%09%3Cpath+class%3D%22colorful+c2%22+fill%3D%22none%22+stroke%3D%22%23000000%22+stroke-width%3D%229%22+stroke-miterlimit%3D%2210%22+d%3D%22M48.887%2C275.749%0A%09%09c-1.803%2C2.75-7.078%2C14.974-8.722%2C17.913c-2.372%2C4.238-5.363%2C6.183-6.779%2C10.441l16.697-22.771c-1.972-2.27-0.865-6.083-1.25-8.337%0A%09%09l-1.56-10.855c-0.5-5.25%2C11.987%2C1.118%2C16.311%2C4.942l8.25-11.087C68.1%2C251.656%2C47.961%2C252%2C53%2C246.25l4.5-6.92%0A%09%09c6.292%2C0%2C21.167%2C13.505%2C20.029%2C3.816l-21.166-9.333c1.637-7.979%2C32.75%2C1.949%2C30.637%2C1.188c-5.369-1.936-10.47-5.012-25.667-19.167%0A%09%09l2.417-7.334c-3.5-6.75%2C34.25%2C32%2C34%2C5.5l-23.5-10c-21.25-16.25%2C21.313%2C2.718%2C32.25%2C0c18.695-4.646-12.406-8.088-10-9.25l28-10.25%0A%09%09c9.25-10-8.833-3.041-13.656-0.912C100.227%2C188.273%2C52.5%2C191%2C76.75%2C182.75l34.5-11c-5.34%2C0-10.181-2.597-15.305-1.738%0A%09%09c-7.236%2C1.213-15.685-0.016-22.997-0.016c-15.149%2C0-36.298%2C0.171-51.447%2C0.171l111.999-7.504c0.039-0.022%2C0.456%2C0.469%2C0.282-0.61%0A%09%09c-5.838-2.3-10.635-2.341-16.952-2.708c-10.946-0.635-22.029-2.458-32.869-4.015c-15.925-2.288-41.809-1.997-56.96-1.997%0A%09%09l96.166-0.671c-8.173%2C0.583-17.37-3.265-25.269-4.943c-7.4-1.572-14.893-1.699-22.315-3.034%0A%09%09c-12.386-2.227-35.267-3.885-47.915-3.935l48.499-6.421c-8.625%2C0-16.988-1.333-25.667-1.333l-7.832-7.162%0A%09%09c-5.417-5.667%2C19.51-0.61%2C31.481-3.171c3.903-0.835%2C7.668-1%2C11.685-1l10-10.333c-2.518-1.078-6.728-0.029-9.66%2C0%0A%09%09c-15.111%2C0.147-30.229%2C0-45.34%2C0l61-10c-3.801-0.027-7.186-0.981-11.014-1.333c-16.068-1.479-32.154-4.006-48.32-4l67.667-8%0A%09%09c-22.836%2C0-45.479-2-68.333-2l47.417-4.162c-5.184-0.391%2C28.367-7.194%2C23.084-7.417c-7.854-0.331-22.711-1.803-30.524-2.537%0A%09%09c-10.851-1.019-22.082-0.218-32.976-0.218l79-10c-4.38-0.286-8.709-1.737-13.334-2c-7.008-0.399-14.154%2C0-21.166%2C0%0A%09%09c-9.234%2C0-18.471-0.061-27.705-0.014c-4.615%2C0.023-9.222%2C1.272-13.796%2C1.014l65.833-7.661c32.667%2C0.667%2C7.413-4.589%2C3-4.583%0A%09%09c-21.633%2C0.025-39.716-3.763-61.499-3.755L141%2C40.918c3.25-5.75-12.318-2.328-17.503-3.257c-10.26-1.84-20.433-1.503-30.789-2.501%0A%09%09C85.35%2C34.451%2C77.91%2C32.818%2C70.5%2C32.996l86.667-8.667c-29.753-2.975-61.558%2C0-92%2C0%22+style%3D%22stroke-dasharray%3A+2297.12%2C+2297.12%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%09%0A%3C%2Fg%3E%0A%3C%2Fsvg%3E"},"external":{}}'
            ),
            array(
                'id' => 'sun-handdrawn-ani',
                'name' => 'Hand drawn Sun',
                'tags' => 'sun animation',
                'group' => 'hand-drawn-graphics',
                'animation' => 1,
                'aspect_ratio' => 1,
                'size' => '90x90',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"90","height":"90","top":0,"left":0},"obj":{"opacity":1,"filter":"blur(0px)"}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"IHyP88","aspect_ratio":"1","content":"%3Csvg+class%3D%22_dn_ani%22+viewBox%3D%220+0+335+322%22%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M186.25%2C121%0A%09c2.604-0.412%2C5.019-0.837%2C8.056-0.602c7.332%2C0.565%2C14.188%2C2.071%2C19.919%2C5.346c14%2C8.002%2C22.421%2C24.438%2C22.421%2C42.486%0A%09c0%2C30.801-27.311%2C55.77-61%2C55.77s-61-24.969-61-55.77c0-17.411%2C6.835-36.519%2C22.104-47.48c9.938-7.134%2C25.706-9.303%2C37.75-10.5%22+style%3D%22stroke-dasharray%3A+356.675%2C+356.675%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M68%2C72%0A%09c0%2C0%2C16.596%2C10.863%2C31.555%2C20.654C111.829%2C100.688%2C123%2C108%2C123%2C108%22+style%3D%22stroke-dasharray%3A+65.7343%2C+65.7343%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M169%2C43%0A%09c0%2C0%2C2.072%2C14.652%2C3.902%2C27.595C174.349%2C80.832%2C175.646%2C90%2C175.646%2C90%22+style%3D%22stroke-dasharray%3A+47.4676%2C+47.4676%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M227%2C108%0A%09c0%2C0%2C3.82-5.943%2C7.941-12.353C239.765%2C88.144%2C245%2C80%2C245%2C80%22+style%3D%22stroke-dasharray%3A+33.2866%2C+33.2866%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M253%2C156%0A%09c0%2C0%2C9.086%2C0%2C18%2C0c8.58%2C0%2C17%2C0%2C17%2C0%22+style%3D%22stroke-dasharray%3A+35%2C+35%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M245%2C224%0A%09c0%2C0%2C8.672%2C6.562%2C17.62%2C13.334C272.153%2C244.549%2C282%2C252%2C282%2C252%22+style%3D%22stroke-dasharray%3A+46.4004%2C+46.4004%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M179.509%2C242%0A%09c0%2C0%2C0.046%2C15.423%2C0.083%2C28.006c0.026%2C8.671%2C0.048%2C15.994%2C0.048%2C15.994%22+style%3D%22stroke-dasharray%3A+44.0002%2C+44.0002%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M128%2C224%0A%09c0%2C0-10.766%2C17.114-20.984%2C33.359C97.785%2C272.034%2C89%2C286%2C89%2C286%22+style%3D%22stroke-dasharray%3A+73.2462%2C+73.2462%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23221F20%22+stroke-width%3D%227.6493%22+stroke-linecap%3D%22round%22+stroke-miterlimit%3D%2210%22+d%3D%22M50%2C202%0A%09c0%2C0%2C12.195-3.658%2C24.54-7.362C87.191%2C190.843%2C100%2C187%2C100%2C187%22+style%3D%22stroke-dasharray%3A+52.2015%2C+52.2015%3B+stroke-dashoffset%3A+0%3B%22%3E%3C%2Fpath%3E%0A%3C%2Fsvg%3E"},"external":{}}'
            ),
            array(
                'id' => 'circle-handdrawn-ani',
                'name' => 'Hand drawn Circle',
                'tags' => 'circle mark animation',
                'group' => 'hand-drawn-graphics',
                'animation' => 1,
                'aspect_ratio' => 1,
                'size' => '90x90',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"90","height":"90","top":0,"left":0},"obj":{"opacity":1,"filter":"blur(0px)"}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"hcvR9n","aspect_ratio":"1","content":"%3Csvg+class%3D%22_dn_ani%22+viewBox%3D%220+0+577+191%22%3E%0A%3Cg%3E%0A%09%3Cpath+class%3D%22colorful+c1%22+fill%3D%22none%22+stroke%3D%22%23000000%22+stroke-width%3D%228.1216%22+stroke-linecap%3D%22round%22+d%3D%22%0A%09%09M392%2C12c-6.438%2C0.303%2C0.771-0.638-1.006-0.212c-0.374%2C0.09-1.792%2C0.191-5.284%2C0.268c-17.528%2C0.383-37.689%2C1.004-56.951%2C3.562%0A%09%09c-29.42%2C3.907-56.754%2C8.431-70.234%2C10.344C186.23%2C36.218%2C84.038%2C72.357%2C29.494%2C112.98c-7.125%2C5.307-16.021%2C13.506-16.522%2C19.709%0A%09%09c0%2C0-1.814%2C7.057%2C2.816%2C13.559c1.847%2C2.595%2C3.994%2C5.299%2C6.712%2C7.252c5.687%2C4.083%2C18.352%2C9.523%2C18.352%2C9.523%0A%09%09s1.943%2C0.566%2C4.614%2C1.341c1.561%2C0.453%2C3.345%2C0.969%2C4.785%2C1.386c3.002%2C0.868-3.741-1.033%2C0.161%2C0.047%0A%09%09c12.739%2C3.529%2C26.309%2C5.291%2C26.309%2C5.291l34.28%2C4.424l43.975%2C1.766c73.411%2C5.503%2C194.35-0.979%2C275.421-13.287%0A%09%09c48.032-7.292%2C115.013-22.102%2C133.358-50.812c17.349-27.149-31.919-38.871-51.049-42.894%0A%09%09c-24.552-5.163-86.758-14.756-148.971-16.603c-24.228-0.717-48.462%2C1.111-67.134%2C2.832C292.819%2C56.864%2C289.282%2C57.404%2C286%2C58%0A%09%09c-2.807%2C0.51-5.471%2C0.692-7.947%2C0.803C272.605%2C59.047%2C268.479%2C61.188%2C265%2C61%22%3E%3C%2Fpath%3E%09%0A%3C%2Fg%3E%0A%3C%2Fsvg%3E"},"external":{}}'
            ),
            array(
                'id' => 'wavy-line-handdrawn-ani',
                'name' => 'Hand drawn Line',
                'tags' => 'wave line animation',
                'group' => 'hand-drawn-graphics',
                'animation' => 1,
                'aspect_ratio' => 1,
                'size' => '90x90',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"90","height":"90","top":0,"left":0}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"PRI13V","aspect_ratio":"1","content":"%3Csvg+class%3D%22_dn_ani%22+viewBox%3D%220+0+191.5+35.333%22%3E%0A%3Cpath+fill%3D%22none%22+class%3D%22colorful+c1%22+stroke%3D%22%23000000%22+stroke-width%3D%221.3297%22+stroke-linecap%3D%22round%22+d%3D%22%0A%09M0%2C21.667C14.39%2C15.55%2C28.49%2C3.071%2C45.794%2C6.089c-5.45%2C9.024-19.253%2C14.179-20.74%2C25.883c0.302%2C0.473%2C0.742%2C0.948%2C1.088%2C1.405%0A%09c17.92%2C1.334%2C27.425-19.623%2C43.699-22.277c-2.035%2C5.422-8.847%2C7.807-10.725%2C13.521c0.76%2C0.625%2C1.92%2C0.25%2C2.593-0.25%0A%09c17.308-5.699%2C32.41-16.422%2C49.896-21.047c-4.237%2C7.165-12.241%2C13.106-14.485%2C21.836c13.591-4.263%2C26.419-14.002%2C40.594-18.781%0A%09c1.514-0.303%2C2.498-0.809%2C3.129-0.28c-0.111%2C0.692-0.258%2C1.895-0.633%2C2.78c-2.682%2C2.905-6.178%2C5.811-6.965%2C9.558%0A%09c0.393%2C0.16%2C1.833-0.144%2C2.971-0.562C146.721%2C11.341%2C157.33%2C2.465%2C169.842%2C1.1c-3.386%2C6.725-13.979%2C10.064-14.408%2C18.409%0A%09c0.693-0.111%2C1.896-0.258%2C2.766-0.633c9.777-6.346%2C20.229-11.713%2C31.405-14.551c-2.272%2C6.204-10.221%2C8.554-13.488%2C14.316%0A%09c0.761%2C0.607%2C1.921%2C0.234%2C2.585-0.277c4.367-1.226%2C8.348-3.013%2C12.799-4.198%22%3E%3C%2Fpath%3E%0A%3C%2Fsvg%3E"},"external":{}}'
            ),
            array(
                'id' => 'curly-line-handdrawn-ani',
                'name' => 'Hand drawn curly Line',
                'tags' => 'curly line animation',
                'group' => 'hand-drawn-graphics',
                'animation' => 1,
                'aspect_ratio' => 1,
                'size' => '90x90',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"90","height":"90","top":0,"left":0},"obj":{"opacity":1,"filter":"blur(0px)"}},"actions":{},"animation":{},"render_html":0,"type":"shape","class":"uE1quV","aspect_ratio":"1","content":"%3Csvg+class%3D%22_dn_ani%22+viewBox%3D%220+0+581+98%22%3E%3Cpath+d%3D%22M62.9+14.9c-25-7.74-56.6+4.8-60.4+24.3-3.73+19.6+21.6+35+39.6+37.6+42.8+6.2+72.9-53.4+116-58.9+65-18.2+191+101+215+28.8+5-16.7-7-49.1-34-44-34+11.5-31+46.5-14+69.3+9.38+12.6+24.2+20.6+39.8+22.9+91.4+9.05+102-98.9+176-86.7+18.8+3.81+33+17.3+36.7+34.6+2.01+10.2.124+21.1-5.18+30.1%22+stroke%3D%22%23000%22+stroke-width%3D%224.3%22+fill%3D%22none%22+class%3D%22colorful+c1%22%3E%3C%2Fpath%3E%3C%2Fsvg%3E"},"external":{}}'
            )
        );

        return apply_filters('_json_stickers', $arr);
    }





    /**
     * Text Templates
     */
    public static function text()
    {
        $arr = array(
            array(
                'id' => 'Annie-use-your-telescope',
                'name' => 'Annie use your telescope',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":294,"height":52,"top":0,"left":0},"obj":{"opacity":1,"filter":"blur(0px)","font-family":"Annie Use Your Telescope"},"element":{"border-radius":0,"border-width":0}},"actions":{},"animation":{},"render_html":0,"type":"text","class":"KTlXpC","aspect_ratio":"0","content":"%3Cdiv%20class%3D%22_dn_elem%22%20style%3D%22border-radius%3A%200px%3B%20border-width%3A%200px%3B%22%3E%3Ch1%20class%3D%22text%20heading%20_dn_text%22%20style%3D%22font-family%3A%20%26quot%3BAnnie%20Use%20Your%20Telescope%26quot%3B%3B%22%3EAnnie%20use%20your%20telescope%3C%2Fh1%3E%3C%2Fdiv%3E","text":"Annie%20use%20your%20telescope","plugins":{"google_font":{"external":{"css":["https://fonts.googleapis.com/css?family=Annie Use Your Telescope"]},"font":"Annie Use Your Telescope"}}},"external":{"styles":{}}}'
            ),
            /*array(
                'id' => 'handdrawn',
                'name' => 'Handdrawn',
                'json' => '{"layer":{"css":{"layer":{"z-index":0,"width":"200","height":"auto","top":0,"left":0},"element":{"color":"rgba(255,87,87,1.01)"},"obj":{"font-size":39,"font-family":"Annie Use Your Telescope"}},"actions":[],"animation":[],"render_html":0,"type":"text","class":"SKtA4w","aspect_ratio":"0","content":"%3Cdiv%20class%3D%22_dn_elem%22%20style%3D%22color%3A%20rgb(255%2C%2087%2C%2087)%3B%22%3E%3Ch1%20class%3D%22text%20heading%20_dn_text%22%20style%3D%22font-size%3A%2039px%3B%20font-family%3A%20%26quot%3BAnnie%20Use%20Your%20Telescope%26quot%3B%3B%22%3EI%26%23039%3Bd%20say%20get%20it!%3C%2Fh1%3E%3C%2Fdiv%3E"},"external":{"styles":{"Annie-Use-Your-Telescope":{"font":"Annie Use Your Telescope","url":"https://fonts.googleapis.com/css?family=Annie Use Your Telescope"}}}}'
            )*/
        );

        return apply_filters('_json_text', $arr);
    }








    /**
     * TEXT EFFECT PLUGINS
     */
    public static function text_effect_plugins()
    {
        $arr = array(

            // https://github.com/chuckyglitch/novacancy.js/
            // $('#object').novacancy({});
            'novacancy' => array(
                'id' => 'novacancy',
                'title' => 'No Vacancy',
                'type' => 'text',
                'desc' => __('Text Neon Golden effect','imc'),
                'external' => array(
                    //'js' => array(IMC_INC_URL.'/plugins/novacancy/jquery.novacancy.js'),
                    'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/novacancy/', 'file' => 'jquery.novacancy.js'))),
                    'css' => array()
                ),
                'code' => array(
                    'run' => '{LAYER}.find("._dn_text").novacancy({PARAMS});', 
                    'remove' => '{LAYER}.find("._dn_text").removeAttr( "novacancy-id" ); {LAYER}.find("._dn_text").find(".novacancy").contents().unwrap();'
                ),
                'params' => array(
                    'reblinkProbability' => (1/3),
                    'blinkMin' => 0.01,
                    'blinkMax' => 0.5,
                    'loopMin' => 0.5,
                    'loopMax' => 2,
                    'color' => 'inherit', // to use actual font color
                    'glow' => array('0 0 80px Orange', '0 0 30px Red', '0 0 6px Yellow'), //array('0 0 80px #ffffff', '0 0 30px #008000', '0 0 6px #0000ff'),
                    'off' => 0,
                    'blink' => 0,
                    'classOn' => 'on',
                    'classOff' => 'off',
                    'element' => 'data',
                    'autoOn' => true,
                    'allow_repeat' => 1 // custom attribute
                ),
                'editing' => array(
                    'reblinkProbability' => array('slider' => array('max' => 10,'min' => 0,'step' => .1)),
                    'blinkMin' => array('slider' => array('max' => 10,'min' => 0,'step' => .1)),
                    'blinkMax' => array('slider' => array('max' => 10,'min' => 0,'step' => .1)),
                    'loopMin' => array('slider' => array('max' => 10,'min' => 0,'step' => .1)),
                    'loopMax' => array('slider' => array('max' => 10,'min' => 0,'step' => .1)),
                    'glow' => array('input' => array()),
                )
            ),


            /**
             * https://github.com/alexmacarthur/typeit
             * !! Nees Commercial License !!
             */
            /*array(
                'id' => 'Typeit',
                'title' => 'Typeit',
                'desc' => __('The most versatile animated typing utility on the planet. |','imc'),
                'external' => array(
                    'js' => array('https://cdnjs.cloudflare.com/ajax/libs/typeit/5.0.2/typeit.min.js'),
                    'css' => array()
                ),
                'code' => array(
                    'run' => 'new TypeIt(".{LAYER-CLASS} ._dn_text", {PARAMS});',
                    'remove' => '{LAYER}.find("._dn_text").removeAttr( "data-typeitid" );{LAYER}.find("._dn_text").find(".ti-container").contents().unwrap();{LAYER}.find("._dn_text").find(".ti-placeholder").remove();{LAYER}.find("._dn_text").find(".ti-cursor").remove();'
                ),
                'params' => array(
                    'lifeLike' => true,
                ),
                'editing' => array(
                    'lifeLike' => array('checkbox' => array('on' => true, 'off' => false))
                )
            ),*/


            // https://mntn-dev.github.io/t.js/
            // https://github.com/mntn-dev/t.js/blob/master/t.min.js
            // $('#object').t({});
            't' => array(
                'id' => 't',
                'title' => 'T. Typewriter',
                'type' => 'text',
                'desc' => __('Typewriter effect','imc'),
                'external' => array(
                    //'js' => array(IMC_INC_URL.'/plugins/t-typewriter/t.min.js'),
                    'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/t-typewriter/', 'file' => 't.min.js'))),
                    'css' => array()
                ),
                'code' => array(
                    'run' => '{LAYER}.find("._dn_text").t({PARAMS});',
                    'remove' => '{LAYER}.find("._dn_text").find(".t-container").contents().unwrap(); {LAYER}.find("._dn_text").find(".t-caret").remove();'
                ),
                'params' => array(
                    'speed' => 50,
                    'speed_vary' =>false,
                    'mistype' => 0,
                    'beep' => false
                ),
                'editing' => array(
                    'speed' => array('slider' => array('min' => 0, 'max' => 100)),
                    'speed_vary' => array('checkbox' => array('on' => true, 'off' => false)),
                    'mistype' => array('slider' => array('min' => 0, 'max' => 10)),
                    'beep' => array('checkbox' => array('on' => true, 'off' => false))
                ),
            ),
            // https://github.com/codrops/Arctext
            // $('#object').arctext({});
            'arctext' => array(
                'id' => 'arctext',
                'title' => 'Arctext',
                'type' => 'text',
                'desc' => __('Arrange text along a curved path','imc'),
                'external' => array(
                    //'js' => array(IMC_INC_URL.'/plugins/t-typewriter/t.min.js'),
                    'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/arctext/', 'file' => 'jquery.arctext.js'))),
                    'css' => array()
                ),
                'code' => array(
                    'run' => '{LAYER}.find("._dn_text").arctext({PARAMS});',
                    'remove' => ''
                ),
                'params' => array(
                    'radius' => 300,
                    'dir' => 1,
                    'rotate' => true,
                    'animation' => 0
                ),
                'editing' => array(
                    'radius' => array('slider' => array('min' => 0, 'max' => 3000, 'step' => 10)),
                    'rotate' => array('checkbox' => array('on' => true, 'off' => false)),
                    'dir' => array('checkbox' => array('on' => 1, 'off' => -1))
                ),
            ),

            // https://code.google.com/archive/p/jqisotext/downloads
            // http://workshop.rs/2010/01/jqisotext-jquery-text-effect-plugin/
            // $('#object').jqIsoText({});
            'jqisotext' => array(
                'id' => 'jqisotext',
                'title' => 'jqIsoText',
                'type' => 'text',
                'desc' => __('Changing the size of letters in text','imc'),
                'external' => array(
                    //'js' => array(IMC_INC_URL.'/plugins/t-typewriter/t.min.js'),
                    'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/jqisotext/', 'file' => 'jqIsoText.min.js'))),
                    'css' => array()
                ),
                'code' => array(
                    'run' => '{LAYER}.find("._dn_text").jqIsoText({PARAMS});',
                    'remove' => ''
                ),
                'params' => array(
                    'fromSize' => 20,
                    'toSize' => 50,
                    'split' => false
                ),
                'editing' => array(
                    'fromSize' => array('slider' => array('min' => 0, 'max' => 1000, 'step' => 1)),
                    'toSize' => array('slider' => array('min' => 0, 'max' => 1000, 'step' => 1)),
                    'split' => array('checkbox' => array('on' => true, 'off' => false))
                ),
            )
        );

        return apply_filters('_json_text_effect_plugins', $arr);
    }





    /**
     * IMAGE EFFECT PLUGINS
     */
    public static function image_effect_plugins()
    {
        $arr = array(
            // https://github.com/jackmoore/zoom
            // $('#object').zoom();
            'jquery_zoom' => array(
                'id' => 'jquery_zoom',
                'title' => 'jQuery Zoom',
                'type' => 'image',
                'desc' => __('Zoom image on hover','imc'),
                'external' => array(
                    'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/jquery-zoom/', 'file' => 'jquery.zoom.min.js'))),
                    'css' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/jquery-zoom/', 'file' => 'jquery.zoom.css')))
                ),
                'code' => array(
                    'run' => '{LAYER}.find(".image").addClass("zoom"); {LAYER}.find(".image").zoom({PARAMS});',
                    'remove' => '{LAYER}.find(".image").removeClass("zoom"); {LAYER}.find(".image").trigger("zoom.destroy");'
                ),
                'params' => array(
                    'on' => 'mouseover',
                ),
                'editing' => array(
                    'on' => array('input' => array()),
                    'on' => array('select' => array(
                        'mouseover','grab','click','toggle'
                    ))
                )
            )
        );

        return apply_filters('_json_image_effect_plugins', $arr);
    }



    /**
     * ANIMATION EFFECT PLUGINS
     */
    public static function animation_effect_plugins()
    {
        $arr = array(

            'imgmce_css_animations' => array(
                'id' => 'imgmce_css_animations',
                'title' => 'imgMCE CSS Animations',
                'type' => 'animation',
                'desc' => __('A cross-browser library of CSS animations for your layers.','imc'),
                'external' => array(
                    'css' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/imgmce_css_animations/', 'file' => 'animations.css')))
                ),
                'code' => array(
                    'run' => '{LAYER}.removeClass("imgmce_ani_infinite dropInFast dropInNormal dropInDlow, dropInHuge");setTimeout(function() {{LAYER}.addClass("{CLASS}")},10); if(typeof({PARAMS}.speed) !== "undefined"){ {LAYER}.addClass("imgmce_ani_"+{PARAMS}.speed);} if(typeof({PARAMS}.loop) !== "undefined" && {PARAMS}.loop){ {LAYER}.addClass("imgmce_ani_infinite"); }', 
                    'remove' => '{LAYER}.removeClass("{CLASS} imgmce_ani_infinite");'
                ),
                'group' => array(
                    'in' => array(),
                    'view' => array(),
                    'out' => array()
                ),
                'params' => array(
                    'class' => 'dropIn',
                    'speed' => 'normal',
                    'loop' => false
                ),
                'editing' => array(
                    'class' => array('select' => array(
                        // Entrances
                        'dropIn','dropInHuge'
                    )),
                    'speed' => array('select' => array(
                        'normal','fast','slow'
                    )),
                    'loop' => array('checkbox' => array('on' => true, 'off' => false))
                )
            ),

            // https://github.com/daneden/animate.css
            // https://daneden.github.io/animate.css/
            'daneden_css_animations' => array(
                'id' => 'daneden_css_animations',
                'title' => 'Daneden CSS Animations',
                'type' => 'animation',
                'desc' => __('A cross-browser library of CSS animations for your layers.','imc'),
                'external' => array(
                    //'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/daneden_css_animations/', 'file' => 'css3-animate-it.js'))),
                    'css' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/daneden_css_animations/', 'file' => 'animate.min.css')))
                ),
                'code' => array(
                    'run' => '{LAYER}.removeClass("animated bounce flash pulse rubberBand shake headShake swing tada wobble jello bounceIn bounceInDown bounceInLeft bounceInRight bounceInUp bounceOut bounceOutDown bounceOutLeft bounceOutRight bounceOutUp fadeIn fadeInDown fadeInDownBig fadeInLeft fadeInLeftBig fadeInRight fadeInRightBig fadeInUp fadeInUpBig fadeOut fadeOutDown fadeOutDownBig fadeOutLeft fadeOutLeftBig fadeOutRight fadeOutRightBig fadeOutUp fadeOutUpBig flip flipInX flipInY flipOutX flipOutY lightSpeedIn lightSpeedOut rotateIn rotateInDownLeft rotateInDownRight rotateInUpLeft rotateInUpRight rotateOut rotateOutDownLeft rotateOutDownRight rotateOutUpLeft rotateOutUpRight slideInUp slideInDown slideInLeft slideInRight slideOutUp slideOutDown slideOutLeft slideOutRight zoomIn zoomInDown zoomInLeft zoomInRight zoomInUp zoomOut zoomOutDown zoomOutLeft zoomOutRight zoomOutUp hinge heartBeat jackInTheBox rollIn rollOut");setTimeout(function() {{LAYER}.addClass("animated {CLASS}")},10);', 
                    'remove' => '{LAYER}.removeClass("animated {CLASS}");'
                ),
                'group' => array(
                    'in' => array(),
                    'view' => array(),
                    'out' => array()
                ),
                'params' => array(
                    'class' => 'bounce'
                ),
                'editing' => array(
                    'class' => array('select' => array(
                        // Attention seekers
                        'bounce','flash','pulse','rubberBand','shake','headShake','swing','tada','wobble','jello',
                        // Bouncing Entrances
                        'bounceIn','bounceInDown','bounceInLeft','bounceInRight','bounceInUp',
                        // Bouncing Exits
                        'bounceOut','bounceOutDown','bounceOutLeft','bounceOutRight','bounceOutUp',
                        // Fading Entrances
                        'fadeIn','fadeInDown','fadeInDownBig','fadeInLeft','fadeInLeftBig','fadeInRight','fadeInRightBig','fadeInUp','fadeInUpBig',
                        // Fading Exits
                        'fadeOut','fadeOutDown','fadeOutDownBig','fadeOutLeft','fadeOutLeftBig','fadeOutRight','fadeOutRightBig','fadeOutUp','fadeOutUpBig',
                        // Flippers
                        'flip','flipInX','flipInY','flipOutX','flipOutY',
                        // Lightspeed
                        'lightSpeedIn','lightSpeedOut',
                        // Rotating Entrances
                        'rotateIn','rotateInDownLeft','rotateInDownRight','rotateInUpLeft','rotateInUpRight',
                        // Rotating Exits
                        'rotateOut','rotateOutDownLeft','rotateOutDownRight','rotateOutUpLeft','rotateOutUpRight',
                        // Sliding Entrances
                        'slideInUp','slideInDown','slideInLeft','slideInRight',
                        // Sliding Exits
                        'slideOutUp','slideOutDown','slideOutLeft','slideOutRight',
                        // Zoom Entrances
                        'zoomIn','zoomInDown','zoomInLeft','zoomInRight','zoomInUp',
                        // Zoom Exits
                        'zoomOut','zoomOutDown','zoomOutLeft','zoomOutRight','zoomOutUp',
                        // Specials
                        'hinge','heartBeat','jackInTheBox','rollIn','rollOut'
                    ))
                )
            ),


            // www.justinaguilar.com/animations/
            'css3-animation-cheetsheet' => array(
                'id' => 'css3-animation-cheetsheet',
                'title' => 'Justinaguilar CSS Animations',
                'type' => 'animation',
                'desc' => __('A cross-browser library of CSS animations for your layers.','imc'),
                'external' => array(
                    'css' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/css3-animation-cheetsheet/', 'file' => 'animations.css')))
                ),
                'code' => array(
                    'run' => '{LAYER}.removeClass("slideDown slideUp slideLeft slideRight slideExpandUp expandUp fadeIn expandOpen bigEntrance hatch bounce pulse floating tossing pullUp pullDown stretchLeft stretchRight");setTimeout(function() {{LAYER}.addClass("{CLASS}")},10);', 
                    'remove' => '{LAYER}.removeClass("{CLASS}");'
                ),
                'group' => array(
                    'in' => array(),
                    'view' => array(),
                    'out' => array()
                ),
                'params' => array(
                    'class' => 'expandOpen'
                ),
                'editing' => array(
                    'class' => array('select' => array(
                        // Entrances
                        'expandOpen','slideDown','slideUp','slideLeft','slideRight','slideExpandUp','expandUp','fadeIn','bigEntrance', 'hatch',
                        // Misc
                        'bounce','pulse','floating','tossing','pullUp','pullDown','stretchLeft','stretchRight'
                    ))
                )
            ),


            // http://jackonthe.net/css3animateit/
            // https://github.com/Jack-McCourt/css3-animate-it
            // https://www.jqueryscript.net/demo/Animate-Elements-In-When-They-Come-Into-View-jQuery-CSS3-Animate-It-Plugin/
            'css3-animate-it' => array(
                'id' => 'css3-animate-it',
                'title' => 'CSS3 Animate It',
                'type' => 'animation',
                'desc' => __('A bunch of cool, fun, and cross-browser animations for your layers.','imc'),
                'external' => array(
                    'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/css3-animate-it/', 'file' => 'css3-animate-it.js'))),
                    'css' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/css3-animate-it/', 'file' => 'animations.css')))
                ),
                'code' => array(
                    'run' => '{LAYER}.removeClass("animated bounceIn bounceInDown bounceInRight bounceInUp bounceInLeft fadeInDown fadeInUp fadeInLeft fadeInRight fadeIn growIn shake shakeUp rotateIn rotateInUpLeft rotateInDownLeft rotateInUpRight rotateInDownRight rollIn wiggle swing tada wobble pulse flip flipInX bounceOut bounceOutUp bounceOutDown bounceOutLeft bounceOutRight fadeOut fadeOutUp fadeOutDown fadeOutLeft fadeOutRight flipOutX flipOutY lightSpeedOutRight lightSpeedOutLeft rotateOut rotateOutUpLeft rotateOutDownLeft rotateOutUpRight rollOut");setTimeout(function() {{LAYER}.addClass("animated {CLASS}")},10);', 
                    'remove' => '{LAYER}.removeClass("animated {CLASS}");'
                ),
                'group' => array(
                    'in' => array(),
                    'view' => array(),
                    'out' => array()
                ),
                'params' => array(
                    'class' => 'bounceIn'
                ),
                'editing' => array(
                    'class' => array('select' => array(
                        'bounceIn','bounceInDown','bounceInRight','bounceInUp','bounceInLeft','fadeInDown','fadeInUp','fadeInLeft',
                        'fadeInRight','fadeIn','shake','rotateIn','rotateInUpLeft','rotateInDownLeft','rotateInUpRight',
                        'rotateInDownRight','rollIn','swing','tada','wobble','pulse','flip','flipInX',
                        'bounceOut','bounceOutUp','bounceOutDown','bounceOutLeft','bounceOutRight','fadeOut','fadeOutUp','fadeOutDown',
                        'fadeOutLeft','fadeOutRight','flipOutX','flipOutY','rotateOut','rotateOutUpLeft',
                        'rotateOutDownLeft','rotateOutUpRight','rollOut' // are not working: 'growIn','lightSpeedOutRight','lightSpeedOutLeft','wiggle','shakeUp',
                    ))
                )
            ),
            
            // $('#object')._imc_animate_shape_width({});
            'imc_animate_shape_width' => array(
                'id' => 'imc_animate_shape_width',
                'title' => 'Animate Shape Width',
                'type' => 'animation',
                'desc' => __('Animate shape width effect.','imc'),
                'external' => array(
                    'js' => array(array('path' => array('dir' => '{INC_DIR}', 'folder' => 'plugins/imc_animate_shape_width/', 'file' => 'imc_animate_shape_width.js'))),
                    'css' => array()
                ),
                'code' => array(
                    'run' => '{LAYER}._imc_animate_shape_width({PARAMS});',
                    'remove' => ''
                ),
                'group' => array(
                    'in' => array(),
                    'view' => array(),
                    'out' => array()
                ),
                'params' => array(
                    'speed' => 1000,
                    'callback' => null
                ),
                'editing' => array(
                    'speed' => array('slider' => array('min' => 0, 'max' => 5000, 'step' => 1))
                ),
            )
        );

        return apply_filters('_json_animation_effect_plugins', $arr);
    }





    public static function build_animations($args = array())
    {
        $arr = array(
            'in' => array(
                'none' => array('name' => 'None'),
                'slideLeft' => array('name' => 'Slide Left'),
                'slideRight' => array('name' => 'Slide Right'),
                'slideUp' => array('name' => 'Slide Up'),
                'slideDown' => array('name' => 'Slide Down'),

                'slideLeftBounce' => array('name' => 'Slide Left Bounce'),
                'slideRightBounce' => array('name' => 'Slide Right Bounce'),
                'slideDownBounce' => array('name' => 'Slide Down Bounce'),
                'slideUpBounce' => array('name' => 'Slide Up Bounce'),
                'expandUp' => array('name' => 'Expand Up'),
                'fadeInBounce' => array('name' => 'Fade In Bounce'),
                'floating' => array('name' => 'Floating'),
                
                'pulse' => array('name' => 'Pulse'),
                'rubberBand' => array('name' => 'Rubber Band'),
                'dropIn' => array('name' => 'Drop In'),
                'dropInHuge' => array('name' => 'Drop In Huge')
            ),
            'out' => array(
                'none' => array('name' => 'None'),
                'fadeOut' => array('name' => 'Fade Out'),
                'rollOut' => array('name' => 'Roll Out'),
                'zoomOut' => array('name' => 'Zoom Out'),
            )
        );

        return apply_filters('_imgmce_build_animations', $arr);
    }
    
}

endif;
?>