<?php
/**
 * Usage:
 *
 * require_once(DIR. '/spr_colorpicker/IMC_ColorPicker.php');
 * new IMC_ColorPicker();
 * IMC_ColorPicker::enqueue_scripts(array('inc_url' => '', 'version' => 0));
 *
*/
if ( ! class_exists( 'IMC_ColorPicker' ) ) :

class IMC_ColorPicker {


	public function __construct() {
		
	}




	/*
	 * enqueue_scripts
	 *
	 * @access public
	 * @return null
	*/
	public static function register_scripts($args = array())
	{
		global $imc_scripts;

		$defaults = array(
			'version' => '2.0',
			'inc_url' => '',
			'inc_dir' => '',
		);
		$args = array_merge( $defaults, $args );

		$imc_scripts->register_script( 'imc_colorpicker_js', $args['inc_url']. '/extensions/imc_colorpicker/assets/dist/jquery.coloring-pick.min.js', array( 'jquery' ), $args['version'], true );
		$imc_scripts->register_script( 'imc_colorpicker_css', $args['inc_url']. '/extensions/imc_colorpicker/assets/dist/jquery.coloring-pick.min.js.css', false, $args['version'], "all" );
	}

}
endif;
?>