<?php
$library = IMC_Main::load_library();
$stickers = ADN_Main::library_sticker_files(IMC_UPLOAD_DIR . 'resources/stickers/');


/**
 * POST
*/
if($_SERVER['REQUEST_METHOD'] == 'POST')
{
	if(isset($_POST['submit_library_btn']))
    {
        $library['stickers'] = ADN_Main::parse_args($_POST['lib_package'], $library['stickers']);
        //echo '<pre>'.print_r($_POST['lib_package'], true).'</pre>';

        update_option('_imgmce_library', $library);
    }

    if(isset($_POST['submit_tpl_library_btn']))
    {
        $library['templates'] = ADN_Main::parse_args($_POST['lib_template'], $library['templates']);
        update_option('_imgmce_library', $library);
    }
}
//echo '<pre>'.print_r($library, true).'</pre>';
?>

<!-- Wordpress Messages -->
<h2 class="messages-position"></h2>

<div class="imgmce_dashboard">
	<div class="wrap">
       
        <?php echo IMC_Templates::admin_header(array(
            'page' => 'packages',
            'title' => 'ImgMCE Packages',
            'desc' => '⚡ ' . __('ImgMCE is designed in a very modular fashion so that lots of functions are customizable. Should you wish to, you can find most general settings below.','imc')
        )); ?>


        <div class="container">

            <!-- TEMPLATE LIBRARY -->
            <div class="spr_row">  
                <div class="spr_column spr_hidden" data-animation="bounce">
                    <div class="spr_column-inner left_column">
                        <div class="spr_wrapper">
                            <div class="option_box">
                                <div class="info_header">
                                    <span class="nr">1</span>
                                    <span class="text"><?php _e('Template Library','imc'); ?></span>
                                </div>
                                <div class="input_container">
                                    <div class="input_container_inner _imc_editor">
                                        
                                        <p style="margin: 20px 0 30px 0;">
                                            ⚡ <?php _e('Upload / Create <em>templates</em> and add them to the <em>templates</em> library.','imc'); ?>
                                        </p>

                                        <form id="TemplateUploader" class="box" method="post" action="<?php echo IMCE_AJAXURL; ?>" enctype="multipart/form-data"></form>
                                        <div id="tpl_upl_result"></div>

                                        <?php echo ADN_Templates::imc_button(array('text' => __('CREATE NEW TEMPLATE','imc'), 'id' => '_open_IMGmceTemplate_Editor')); ?>


                                        <form action="" method="post" id="imc-template-library">
                                            <div class="imc_settings_cont imc_template_library imc_shape_library ">
                                                <h4><?php _e('Template Library','imc'); ?></h4>
                                                
                                                <div class="imc_templates_cont_inner imc_settings_cont_inner" style="padding:0;">
                                                    <?php
                                                    $h = '';
                                                    $upload_dir = IMC_UPLOAD_DIR;
                                                    $templates = ADN_Main::library_template_files($upload_dir . 'resources/templates/');
                                                    
                                                    $h.= '<div class="_lib_container">';
                                                    if(!empty($templates))
                                                    {
                                                        $h.= '<div class="_lib_menu _lib_templates">';
                                                            $i = 0;
                                                            foreach($templates as $key => $template)
                                                            {
                                                                if(!empty($template) && !empty($key))
                                                                {
                                                                    if( !empty($template[0]))
                                                                    {
                                                                        $selected = !$i ? ' selected' : '';
                                                                        $active_class = '';
                                                                        $h.= '<a class="_lib_cat'.$selected.$active_class.'" data-menu="templates" data-cat="'.$key.'">';
                                                                            $h.= '<div class="title">'.$key.'</div>';
                                                                        $h.= '</a>';
                                                                        $i++;
                                                                    }
                                                                }
                                                            }
                                                        $h.= '</div>';

                                                        $h.= '<div class="_lib_objects_container _lib_templates">';
                                                            $i = 0;
                                                            foreach($templates as $key => $template)
                                                            {
                                                                if(!empty($template) && !empty($key))
                                                                {
                                                                    if( !empty($template[0]))
                                                                    {
                                                                        $checked = array_key_exists($key, $library['templates']) ? $library['templates'][$key]['active'] : 0;
                                                                        $selected = !$i ? ' selected' : '';
                                                                        $h.= '<div class="_lib_objects '.$key.$selected.'">';

                                                                            $h.= '<div class="_lib_obj_settings">';
                                                                                $h.= '<div style="margin-bottom:10px;"><strong>'.__('Package settings','imc').'</strong></div>';
                                                                                $h.= ADN_Templates::checkbox(array(
                                                                                    'title' => __('Active','imc'),
                                                                                    'tooltip' => __('Define if the template should be available in the imgMCE editor.','imc'),
                                                                                    'checked' => $checked,
                                                                                    'value' => 1,
                                                                                    'name' => 'lib_template['.$key.'][active]',
                                                                                    'class' => 'option_checkbox imc_lib_template',
                                                                                    'hidden_input' => 1
                                                                                ));
                                                                                
                                                                                //$h.= '<a class="export_tpl_btn export_btn" data-tpl="'.$key.'">'.__('Export','imc').'</a>';
                                                                                $h.= '<textarea class="_lib_tpl_json_code json_code_'.$key.'" style="display:none;">'.json_encode($template[0]['json']).'</textarea>';
                                                                            $h.= '</div>';

                                                                            
                                                                            $h.= '<div class="_lib_svgs">';
                                                                                $h.= '<div class="_lib_tpl_item" style="width:200px;" data-id="'.$key.'">'.ADN_Templates::banner_tpl($template[0]['json'], array('load_always' => 0)).'</div>';
                                                                            $h.= '</div>';

                                                                            $h.= '<div class="clearFix"></div>';
                                                                        $h.= '</div>';
                                                                        $i++;
                                                                    }
                                                                }
                                                            }
                                                            $h.= '<input type="submit" name="submit_tpl_library_btn" id="submit_tpl_library_btn" class="button button-primary" value="'.__('Save Changes','imc').'" style="display:inline-block;width:auto;margin:0 10px 10px;">';
                                                            $h.= '<a class="remove_template_btn button" style="display:inline-block;width:auto;">'.__('Remove','imc').'</a>';
                                                            $h.= '<a class="export_template button" style="margin-left: 10px;"><svg viewBox="0 0 512 512" style="width:20px;margin:3px 0 0 0;"><path fill="currentColor" d="M216 0h80c13.3 0 24 10.7 24 24v168h87.7c17.8 0 26.7 21.5 14.1 34.1L269.7 378.3c-7.5 7.5-19.8 7.5-27.3 0L90.1 226.1c-12.6-12.6-3.7-34.1 14.1-34.1H192V24c0-13.3 10.7-24 24-24zm296 376v112c0 13.3-10.7 24-24 24H24c-13.3 0-24-10.7-24-24V376c0-13.3 10.7-24 24-24h146.7l49 49c20.1 20.1 52.5 20.1 72.6 0l49-49H488c13.3 0 24 10.7 24 24zm-124 88c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20zm64 0c0-11-9-20-20-20s-20 9-20 20 9 20 20 20 20-9 20-20z"></path></svg></a>';
                                                        $h.= '</div>';
                                                        
                                                    }
                                                    $h.= '<div class="clearFix"></div>';
                                                    $h.= '</div>';
                                                    echo $h;
                                                    //echo '<pre>'.print_r($templates).'</pre>';
                                                    ?>
                                                </div>
                                            </div>
                                        </form>
                                        
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- end Template LIBRARY -->



            <!-- SHAPES LIBRARY -->
            <div class="spr_row">  
                <div class="spr_column spr_hidden" data-animation="bounce">
                    <div class="spr_column-inner left_column">
                        <div class="spr_wrapper">
                            <div class="option_box">
                                <div class="info_header">
                                    <span class="nr">2</span>
                                    <span class="text"><?php _e('Shape Library','imc'); ?></span>
                                </div>
                                <div class="input_container">
                                    <div class="input_container_inner">
                                        
                                        <p style="margin: 20px 0 30px 0;">
                                            ⚡ <?php _e('Upload <em>sticker packages</em> to the <em>shapes</em> library.','imc'); ?>
                                        </p>
                                        
                                        <form id="PackageUploader" class="box" method="post" action="<?php echo IMCE_AJAXURL; ?>" enctype="multipart/form-data"></form>
                                        <div id="upl_result"></div>

                                    </div>
                                    <span class="description bottom"><?php _e('Packages need to be <em>.zip</em> files containing </em>.svg</em> objects.','imc'); ?></span>
                                
                                
                                    <form action="" method="post" id="imc-shape-library">
                                        <div class="imc_settings_cont imc_shape_library">
                                            <h4><?php _e('Shape Library','imc'); ?></h4>
                                            
                                            <div class="imc_settings_cont_inner" style="padding:0;">
                                                
                                                <?php
                                                $h = '';
                                                $upload_dir = IMC_UPLOAD_DIR;
                                                $shapes = ADN_Main::library_sticker_files($upload_dir . 'resources/stickers/');

                                                $h.= '<div class="_lib_container">';
                                                if(!empty($shapes))
                                                {
                                                    $h.= '<div class="_lib_menu _lib_shapes">';
                                                        $i = 0;
                                                        foreach($shapes as $group_key => $group)
                                                        {
                                                            $active = array_key_exists($group_key, $library['stickers']) ? $library['stickers'][$group_key]['active'] : 0;
                                                            $active_class = $active ? ' active' : '';
                                                            $selected = !$i ? ' selected' : '';
                                                            $h.= '<a class="_lib_cat'.$selected.$active_class.'" data-menu="shapes" data-cat="'.$group_key.'">';
                                                                $h.= '<div class="title">'.$group_key.'</div>';
                                                            $h.= '</a>';
                                                            $i++;
                                                        }
                                                    $h.= '</div>';

                                                    $h.= '<div class="_lib_objects_container _lib_shapes">';
                                                        $i = 0;
                                                        foreach($shapes as $group_key => $group)
                                                        {
                                                            $checked = array_key_exists($group_key, $library['stickers']) ? $library['stickers'][$group_key]['active'] : 0;
                                                            $title = array_key_exists($group_key, $library['stickers']) ? stripslashes($library['stickers'][$group_key]['title']) : $group_key;
                                                            $desc = array_key_exists($group_key, $library['stickers']) ? stripslashes($library['stickers'][$group_key]['desc']) : '';
                                                            
                                                            $selected = !$i ? ' selected' : '';
                                                            $h.= '<div class="_lib_objects '.$group_key.$selected.'">';
                                                                $h.= '<div class="_lib_obj_settings">';
                                                                    $h.= '<div style="margin-bottom:10px;"><strong>'.__('Package settings','imc').'</strong></div>';
                                                                    $h.= ADN_Templates::checkbox(array(
                                                                        'title' => __('Active','imc'),
                                                                        'tooltip' => __('Define if the package should be available in the imgMCE editor.','imc'),
                                                                        'checked' => $checked,
                                                                        'value' => 1,
                                                                        'name' => 'lib_package['.$group_key.'][active]',
                                                                        'class' => 'option_checkbox imc_lib_package',
                                                                        'hidden_input' => 1
                                                                    ));
                                                                    $h.= IMC_Templates::inpt_cont(array(
                                                                        'type' => 'text',
                                                                        'title' => __('Package Title','imc'),
                                                                        'desc' => __('','imc'),
                                                                        'name' => 'lib_package['.$group_key.'][title]',
                                                                        'value' => $title,
                                                                        'placeholder' => __('Package title','imc'),
                                                                        'desc_pos' => 'bottom'
                                                                    ));
                                                                    $h.= IMC_Templates::textarea_cont(array(
                                                                        'title' => __('Package Description','imc'),
                                                                        'desc' => __('','imc'),
                                                                        'name' => 'lib_package['.$group_key.'][desc]',
                                                                        'value' => $desc,
                                                                        'placeholder' => __('Package description','imc'),
                                                                        'desc_pos' => 'bottom'
                                                                    ));
                                                                $h.= '</div>';
                                                                $h.= '<div class="_lib_svgs">';
                                                                    foreach($group as $key => $shape)
                                                                    {
                                                                        if( is_array($shape) && array_key_exists('filename', $shape))
                                                                        {
                                                                            $h.= '<div class="_lib_obj" data-group="'.$group_key.'" data-key="'.$shape['filename'].'">';
                                                                                $h.= $shape['svg'];
                                                                            $h.= '</div>';
                                                                        }
                                                                    }
                                                                $h.= '</div>';
                                                                $h.= '<div class="clearFix"></div>';
                                                            $h.= '</div>';
                                                            $i++;
                                                        }
                                                        $h.= '<input type="submit" name="submit_library_btn" id="submit_library_btn" class="button button-primary" value="'.__('Save Changes','imc').'" style="display:inline-block;width:auto;margin:0 10px 10px;">';
                                                        $h.= '<a class="remove_shape_bundle_btn button" style="display:inline-block;width:auto;">'.__('Remove','imc').'</a>';
                                                    $h.= '</div>';
                                                    $h.= '<div class="clearFix"></div>';
                                                }
                                                else
                                                {
                                                    $h.= '<div style="padding:10px;">'.__('No packages found','imc').'</div>';
                                                }
                                                $h.= '</div>';
                                                echo $h;
                                                ?>

                                            </div>
                                        </div>
                                        <!-- end .imc_shape_library -->
                                    </form>


                                </div>
                                <!-- end .input_container -->
                            </div>
                        </div>
                    </div>
                </div>
                
            </div>
            <!-- end .spr_row -->
        
        </div>
        <!-- end .container -->

    </div>
</div>

<script type="text/javascript">
jQuery(document).ready(function($) {

    ImgMCE_global.activate_tooltips($('.imgmce_dashboard'));

	$(".spr_column").inViewport(function(px){
		var animation = $(this).data('animation');
		if( typeof animation !== 'undefined' && animation != ''){
			if(px) $(this).addClass(animation+" spr_visible animated");
		}
    }, {padding:0});

    // Remove shape bundle
    $('.remove_shape_bundle_btn').on('click', function(){
        var obj_id = $('._lib_menu._lib_shapes').find('.selected').data('cat');

        if (!confirm('Are you sure you want to remove this bundle: '+obj_id+'?')) {
            return false;
        }
        console.log('Yes, Remove shape bundle '+obj_id);
        console.log('<?php echo IMC_UPLOAD_DIR; ?>'+'resources/stickers/'+obj_id+'/');

        $.ajax({
            type: "POST",
            url: _dn_.ajaxurl,
            data: {
                "action": "remove_folder",
                "upload": JSON.stringify({
                    "upload_folder": 'resources/stickers/'+obj_id+'/',
                    "upload_dir": '<?php echo IMC_UPLOAD_DIR; ?>'
                }),
                "id": obj_id
            }
        }).done(function( msg ){
            var obj = JSON.parse(msg);

            if( obj.removed ){
                _dn_reload_page();
            }else{
                alert(obj.msg);
            }
        });
    });



    $('#_open_IMGmceTemplate_Editor').on('click', function(){
        //_packagee_open_tpl_editor();
        ImgMCE_global.load_editor({
            "editor": {
                "upload": {
                    "structure": "{DIR}/{FOLDER}/{ID}",
                    "folder": "resources/templates/",
                },
                "callback": "_dn_reload_page"
            }
        });
    });    
    
    

    // Click on tpl_item.
    $('._lib_tpl_item').on('click', function(){
        var id = $(this).data('id'),
            json = JSON.parse($('.json_code_'+id).val());
        
        console.log( json );

        //_packagee_open_tpl_editor({'banner_obj':json});
        ImgMCE_global.load_editor({
            "banner_obj": json,
            "editor": {
                "upload": {
                    "structure": "{DIR}/{FOLDER}/{ID}",
                    "folder": "resources/templates/",
                },
                "callback": "_dn_reload_page"
            }
        });
    });
    


    // Library menu actions
    $('._lib_menu').on('click', '._lib_cat', function(){
        
        var lib = $(this).data('menu');
        $('._lib_menu._lib_'+lib).find('._lib_cat').removeClass('selected');
        $('._lib_objects_container._lib_'+lib).find('._lib_objects').removeClass('selected');

        $(this).addClass('selected');
        $('._lib_objects_container._lib_'+lib).find('.'+$(this).data('cat')).addClass('selected');

        window.dispatchEvent(new Event('resize'));
        // Set timeout to a milisecond before loading the banner to fix the problem when display:none; has no hight.
        //setTimeout(function(){ window.dispatchEvent(new Event('resize')); }, 1);
    });


    // Remove Template
    $('.remove_template_btn').on('click', function(){
        var obj_id = $('._lib_menu._lib_templates').find('.selected').data('cat');

        if (!confirm('Are you sure you want to remove this template: '+obj_id+'?')) {
            return false;
        }
        console.log('Yes, Remove template '+obj_id);
        console.log('<?php echo IMC_UPLOAD_DIR; ?>'+'resources/templates/'+obj_id+'/');

        $.ajax({
            type: "POST",
            url: _dn_.ajaxurl,
            data: {
                "action": "remove_folder",
                "upload": JSON.stringify({
                    "upload_folder": 'resources/templates/'+obj_id+'/',
                    "upload_dir": '<?php echo IMC_UPLOAD_DIR; ?>'
                }),
                "id": obj_id
            }
        }).done(function( msg ){
            var obj = JSON.parse(msg);

            if( obj.removed ){
                _dn_reload_page();
            }else{
                alert(obj.msg);
            }
        });
    });
    
    





    // .ZIP packages uploads
    $('#PackageUploader')._dn_file_uploader({
        'max_upload_size': 1000,
        'upload': {
            'folder': 'resources/stickers/',
            'dir': '<?php echo IMC_UPLOAD_DIR; ?>',
            'src': '<?php echo IMC_UPLOAD_SRC; ?>'
        },
        'allowed_file_types': ['zip'],
        'text': {
            'upload': '<strong>Click here</strong><span class="box__dragndrop"> or drag .zip file to upload</span>.',
            'upload_info': 'Max. size 1000 MB. <strong><em>.ZIP</em> files only.</strong>',
        },
        'callback': function(src){
            console.log('after upload callback '+src);
        }
    });

    // .ZIP templates uploads
    $('#TemplateUploader')._dn_file_uploader({
        'max_upload_size': 1000,
        'upload': {
            'folder': 'resources/templates/',
            'dir': '<?php echo IMC_UPLOAD_DIR; ?>',
            'src': '<?php echo IMC_UPLOAD_SRC; ?>'
        },
        'allowed_file_types': ['zip'],
        'text': {
            'upload': '<strong>Click here</strong><span class="box__dragndrop"> or drag .zip file to upload</span>.',
            'upload_info': 'Max. size 1000 MB. <strong><em>.ZIP</em> files only.</strong>',
        },
        'callback': function(src){
            console.log('after upload callback '+src);
        }
    });


    // Export template
    //$('.export_tpl_btn').on('click', function(){
    $('.export_template').on('click', function(){
        //var obj_id = $(this).data('tpl');
        var obj_id = $('._lib_menu._lib_templates').find('.selected').data('cat');

        $.ajax({
            type: "POST",
            url: _dn_.ajaxurl,
            data: {
                "action": "export_folder",
                "upload": JSON.stringify({
                    "folder": 'resources/templates/',
                    "dir": '<?php echo IMC_UPLOAD_DIR; ?>',
                    "src": '<?php echo IMC_UPLOAD_SRC; ?>'
                }),
                "id": obj_id
            }
        }).done(function( msg ){
            var obj = JSON.parse(msg);
            
            if( obj.zipped ){
                window.location = obj.src;
            }else{
                console.log(obj);
            }
        });
    });
});


function _dn_reload_page(){
    location.reload();
}
</script>