<?php
//delete_option( '_imgmce_settings' );
$settings = IMC_Main::load_settings();

/**
 * IF POST DATA
*/
if($_SERVER['REQUEST_METHOD'] == 'POST')
{
    if(isset($_POST['submit_btn']))
    {
        // Debug
        $settings['debug'] = $_POST['debug'];

        // Image Settings
        $settings['image'] = ADN_Main::parse_args($_POST['imc_settings']['images'], $settings['image']);
        //echo '<pre>'.print_r($default_settings['image'], true).'</pre>';

        // File types
        $file_types_arr = array();
        if(!empty($_POST['imc_settings']['images']['upload_file_types']))
        {
            foreach($_POST['imc_settings']['images']['upload_file_types'] as $key => $val)
            {
                $file_types_arr[] = $key;
            }
        }
        $settings['image']['upload_file_types'] = $file_types_arr;
        //$settings['image']['stock_providers']['giphy']['url'] = 'http://api.giphy.com/v1/';
        

        // UPDATE SETTINGS
        update_option('_imgmce_settings', $settings);
    }
}
//echo '<pre>'.print_r($settings, true).'</pre>';
?>

<!-- Wordpress Messages -->
<h2 class="messages-position"></h2>

<div class="imgmce_dashboard">
	<div class="wrap">
       
        <?php echo IMC_Templates::admin_header(array(
            'page' => 'settings',
            'title' => 'ImgMCE General Settings',
            'desc' => '⚡ ' . __('ImgMCE is designed in a very modular fashion so that lots of functions are customizable. Should you wish to, you can find most general settings below.','imc')
        )); ?>

        <div class="container">

            <form action="" method="post" id="imc-role-settings">

                <div class="spr_row">  
                    <!-- /**
                    * 6 x 6
                    */ -->
                    <div class="spr_column spr_col-6 spr_hidden" data-animation="bounce">
                        <div class="spr_column-inner left_column">
                            <div class="spr_wrapper">
                                <div class="option_box">
                                    <div class="info_header">
                                        <span class="nr">1</span>
                                        <span class="text"><?php _e('3rd party API integrations','imc'); ?></span>
                                    </div>
                                    <div class="input_container">
                                        <div class="input_container_inner">
                                            <?php
                                            $html = '';
                                            $html.= '<div class="imc_settings_cont">';
                                                $html.= '<h4>'.__('Stock Images','imc').'</h4>';
                                                $html.= '<div class="imc_settings_cont_inner">';
                                                    // Stock (Unsplash)
                                                    $html.= ADN_Templates::checkbox(array(
                                                        'title' => __('Stock Images','imc'),
                                                        'tooltip' => sprintf(__('Enable/Disable stock images delivered by %s.','imc'),'Unsplash'),
                                                        'checked' => !empty($settings['image']) ? $settings['image']['stock_images'] : 1,
                                                        'value' => 1,
                                                        'name' => 'imc_settings[images][stock_images]',
                                                        'class' => 'option_checkbox',
                                                        'data' => array('box' => 'imc_enable_stock_images' ),
                                                        'hidden_input' => 1
                                                    ));
                                            
                                                    $html.= IMC_Templates::inpt_cont(array(
                                                        'type' => 'text',
                                                        'width' => '100%',
                                                        'title' => 'Unsplash Application ID',
                                                        'desc' => '<a href="https://unsplash.com/documentation#registering-your-application" target="_blank">Register your free Unsplash application</a> to use stock images.',
                                                        'name' => 'imc_settings[images][stock_providers][unsplash][application_id]',
                                                        'value' => $settings['image']['stock_providers']['unsplash']['application_id'],
                                                        'placeholder' => 'Unsplash Application ID',
                                                        'desc_pos' => 'bottom'
                                                    ));
                                                $html.= '</div>';
                                            $html.= '</div>';

                                            // GIPHY
                                            $html.= '<div class="imc_settings_cont">';
                                                $html.= '<h4>'.__('Animated GIFs','imc').'</h4>';
                                                $html.= '<div class="imc_settings_cont_inner">';
                                                    $html.= '<p>';
                                                        $html.= sprintf(__("%s lets you search the world's largest library of animated GIFs.","imc"), '<a href="https://giphy.com/" target="_blank">GIPHY</a>');
                                                    $html.= '</p>';
                                                    /*$html.= ADN_Templates::checkbox(array(
                                                        'title' => __('Enable GIPHY','imc'),
                                                        'tooltip' => sprintf(__('Enable/Disable animated gif images delivered by %s.','imc'),'GIPHY'),
                                                        'checked' => !empty($settings['image']) ? $settings['image']['giphy'] : 1,
                                                        'value' => 1,
                                                        'name' => 'imc_settings[images][giphy]',
                                                        'class' => 'option_checkbox',
                                                        'data' => array('box' => 'imc_enable_giphy' ),
                                                        'hidden_input' => 1
                                                    ));*/
                                            
                                                    $html.= IMC_Templates::inpt_cont(array(
                                                        'type' => 'text',
                                                        'width' => '100%',
                                                        'title' => 'GIPHY Api key',
                                                        'desc' => '<a href="https://developers.giphy.com/dashboard/?create=true" target="_blank">Register your free GIPHY App</a> to use animated gif images.',
                                                        'name' => 'imc_settings[images][stock_providers][giphy][application_id]',
                                                        'value' => $settings['image']['stock_providers']['giphy']['application_id'],
                                                        'placeholder' => 'GIPHY Api key',
                                                        'desc_pos' => 'bottom'
                                                    ));
                                                $html.= '</div>';
                                            $html.= '</div>';

                                            echo $html;
                                            ?>
                                        </div>
                                        <span class="description bottom"><?php _e('','imc'); ?></span>
                                    </div>
                                    <!-- end .input_container -->
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="spr_column spr_col-6 spr_hidden" data-animation="zoomIn">
                        <div class="spr_column-inner">
                            <div class="spr_wrapper">
                                <div class="option_box">
                                    <div class="info_header">
                                        <span class="nr">⚡</span>
                                        <span class="text"><?php _e('Server Status','imc'); ?></span>
                                    </div>
                                    <div class="input_container">
                                        
                                        <div class="system_status">
                                            <p style="border-bottom: solid 1px #e2e2e2;padding:0 0 10px 0;margin-bottom: 20px;">
                                                <?php _e("Let's see if your server is ready to run imgMCE. If any of the options below are not available please install the missing functions or contact your hosting provider.", 'imc'); ?>
                                            </p>
                                            <div class="option_box">
                                                <?php 
                                                _e('Uploads Folder Writable:', 'imc');
                                                $wp_uploads = wp_get_upload_dir();
                                                if ( wp_is_writable( $wp_uploads['basedir'] ) ) {
                                                    _e( '<code class="status-good">Yes</code>', 'imc' ); 
                                                } else {
                                                    echo sprintf( __( '<code class="status-bad">No</code> Uploads folder must be writable to allow WordPress function properly.<br><span>See <a href="%1$s" target="_blank">changing file permissions</a> or contact your hosting provider.</span>', 'imc' ), 'https://codex.wordpress.org/Changing_File_Permissions' );
                                                }
                                                ?>
                                            </div>
                                            <div class="option_box">
                                                <?php
                                                _e('WP Memory Limit:', 'imc');
                                                $wp_memory_limit = wp_convert_hr_to_bytes( WP_MEMORY_LIMIT );
                                                if ( function_exists( 'memory_get_usage' ) ) {
                                                    $wp_memory_limit = max( $wp_memory_limit, wp_convert_hr_to_bytes( @ini_get( 'memory_limit' ) ) );
                                                }
                                                $memory = $wp_memory_limit;
                                                
                                                if ( $memory < 67108864 ) {
                                                    echo sprintf( __( '<code class="status-bad">%1$s</code> Minimum value is <strong>64 MB</strong>. <strong>128 MB</strong> is recommended.', 'imc' ), size_format( $memory ) );
                                                    echo $tip;
                                                }
                                                else if ( $memory < 134217728 ) {
                                                    echo sprintf( __( '<code class="status-okay">%1$s</code> Current memory limit is sufficient for most tasks. However, recommended value is <strong>128 MB</strong>.', 'imc' ), size_format( $memory ) );
                                                    echo $tip;
                                                }
                                                else if ( $memory < 268435456 ) {
                                                    echo sprintf( __( '<code class="status-good">%1$s</code>', 'imc' ), size_format( $memory ) );
                                                    echo $tip;
                                                }
                                                else {
                                                    echo sprintf( __( '<code class="status-good">%1$s</code>', 'imc' ), size_format( $memory ) );
                                                }
                                                ?>
                                            </div>
                                            <div class="option_box">
                                                <?php 
                                                _e('ZipArchive Support:', 'imc');
                                                if ( class_exists( 'ZipArchive' ) ) {
                                                    _e( '<code class="status-good">Yes</code>', 'imc' ); 
                                                } else {
                                                    echo sprintf( __( '<code class="status-bad">No</code> ZipArchive is required for importing/exporting objects and templates.<br><span>Please contact your hosting provider.</span>', 'imc' ));
                                                }
                                                ?>
                                            </div>
                                            <div class="option_box">
                                                <?php 
                                                _e('PHP Version:', 'imc');
                                                if(phpversion() >= 5.3){
                                                    echo '<code class="status-good">'.phpversion().'</code>';
                                                }else{
                                                    echo sprintf(__('<code class="status-okay">%s</code> ImgMCE has not been tested with PHP versions under 5.3.','imc'), phpversion());
                                                }
                                                ?>
                                            </div>
                                        </div>
                                        <div>
                                            <?php echo ADN_Templates::checkbox(array(
                                                    'title' => __('Debug','imc'),
                                                    'tooltip' => __('Run plugin in debug mode.','imc'),
                                                    'checked' => array_key_exists('debug',$settings) ? $settings['debug'] : 0,
                                                    'value' => 1,
                                                    'hidden_input' => 1,
                                                    'name' => 'debug',
                                                    'class' => 'option_checkbox _debug'
                                                ));
                                            ?>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- end .spr_row -->

                <input type="submit" name="submit_btn" id="submit_btn" class="button button-primary" value="<?php _e('Save Changes','imc'); ?>" style="display: inline-block;width: auto;">
            </form>
         
        </div>
        <!-- end .container -->

    </div>
    <!-- end .wrap -->
</div>

<script type="text/javascript">
jQuery(document).ready(function($) {

    ImgMCE_global.activate_tooltips($('.imgmce_dashboard'));

	$(".spr_column").inViewport(function(px){
		var animation = $(this).data('animation');
		if( typeof animation !== 'undefined' && animation != ''){
			if(px) $(this).addClass(animation+" spr_visible animated");
		}
	}, {padding:0});
});
</script>